import java.awt.*;
import java.awt.event.*;
import java.awt.print.*;
import java.awt.image.*;
import java.awt.geom.*;
import javax.swing.*;
import java.io.*;
import java.util.*;
import java.awt.datatransfer.*;

/**
 * <p>Title: </p>
 * <p>Description: </p>
 * <p>Copyright: Copyright (c) 2002</p>
 * <p>Company: </p>
 * @author unascribed
 * @version 1.0
 */





//public class DrawingArea extends JFrame implements MouseMotionListener
public class DrawingArea extends JFrame implements MouseListener, MouseMotionListener, ClipboardOwner
{
  JPanel contentPane;
  JScrollPane jScrollPane1 = new JScrollPane();
  JMenuBar menuBar = new JMenuBar();
    //menuBar.setOpaque(true);
  JMenu fileMenu = new JMenu();
  JMenu editMenu = new JMenu();
    //JMenu helpMenu = new JMenu();
  JMenuItem fileNew = new JMenuItem();
  JMenuItem fileOpen = new JMenuItem();
  JMenuItem fileSave = new JMenuItem();
  JMenuItem fileSaveAs = new JMenuItem();
  JMenuItem fileClose = new JMenuItem();
  JMenuItem fileExit = new JMenuItem();
  JMenuItem editUndo = new JMenuItem();
  JMenuItem selectAll = new JMenuItem();
  JMenuItem unselectAll = new JMenuItem(); 
  JMenuItem editCut = new JMenuItem();
  JMenuItem editCopy = new JMenuItem();
  JMenuItem editPaste = new JMenuItem();
  JMenuItem editDelete = new JMenuItem();
  JMenuItem editSendToBack = new JMenuItem();
  JMenuItem editBringToFront = new JMenuItem();
    //JMenuItem helpAbout = new JMenuItem();
  JPanel jPanel1 = new JPanel();
  JFileChooser fileDialogBox = new JFileChooser();
  BorderLayout borderLayout1 = new BorderLayout();
    //JMenuItem helpContents = new JMenuItem();
  JMenuItem filePrint = new JMenuItem();
  Vector CutShapes = new Vector();
  Vector CopyShapes = new Vector();
  boolean canPaste = false;
  boolean clean = true;
  public static ObjectOrientedDrawer owner;
  int numClicks = 0;
  public static Vector Shapes = new Vector();      // vector to print shapes
  Vector Shapes2 = new Vector();
  Vector Points = new Vector();      // vector of points of shapes
  public static Vector draggedPts = new Vector();  // vector of points that dragged mouse
  boolean dragged = false;
  Vector Commands = new Vector();   // vector list of commands
  String lastcommand;              // the last command for the undo
  public static boolean isFixed = false;

/*****Points used for dragging*******/
  Point startPoint = new Point();
  Point endPoint = new Point();
  Point stopPoint = new Point(-1, -1);
/*************************************/

  int start = 0;


      public void drawArrowDownLeft(Graphics g, Point p2){
         g.drawLine((int)p2.getX()+20, (int) p2.getY(), (int)p2.getX(), (int)p2.getY());
         g.drawLine((int)p2.getX(), (int) p2.getY()-20, (int)p2.getX(), (int)p2.getY());
      }

      public void drawArrowUpLeft(Graphics g, Point p2){
         g.drawLine((int)p2.getX()+20, (int) p2.getY(), (int)p2.getX(), (int)p2.getY());
         g.drawLine((int)p2.getX(), (int) p2.getY()+20, (int)p2.getX(), (int)p2.getY());
      }

      public void drawArrowDownRight(Graphics g, Point p2){
         g.drawLine((int)p2.getX() - 20, (int) p2.getY(), (int)p2.getX(), (int)p2.getY());
         g.drawLine((int)p2.getX(), (int) p2.getY()-20, (int)p2.getX(), (int)p2.getY());
      }

      public void drawArrowUpRight(Graphics g, Point p2){
         g.drawLine((int)p2.getX() - 20, (int) p2.getY(), (int)p2.getX(),(int)p2.getY());
         g.drawLine((int)p2.getX(), (int) p2.getY()+20, (int)p2.getX(), (int)p2.getY());
      }

   //anshu3
   /**
   The fill_arrowhead function is from the subArctic toolkit (which can be
   found at: http://www.cc.gatech.edu/gvu/ui/sub_arctic).
      
   * Draw a filled arrowhead polygon at the second end of the given line (this
   * does not draw the line).<p>
   *
   * @param int    x1               first x coordinate of the line
   * @param int    y1               first y coordinate of the line
   * @param int    x2               second x coordinate of the line (arrow
   *                                head point goes here)
   * @param int    y2               second y coordinate of the line (arrow
   *                                head point goes here)
   * @param int    arrow_head_len   length of the sides of the arrow head
   * @param int    arrow_head_angle angle between each side and the line in
   *                                degrees
   * @param double arrow_inset      percent inset for base of arrow [0..1]
   *                                (values around 0.60 seem to work well).
   */

    public void fill_arrowhead(int x1, int y1, int x2, int y2,
    int arrow_head_len, int arrow_head_angle, double arrow_inset, Graphics g)
    {  
      /* length of the target line we are drawing arrowhead over */
      double dx, dy, len;
   
      /* values for rotation needed to get from canonical line to target */
      double sin_theta, cos_theta;
   
      /* coordinates and values for canonical arrowhead placed on x axis */
      double pt1_x, pt1_y, pt2_x, pt2_y, pt3_x, pt3_y;
      double ah_len = (double)arrow_head_len;
      double ah_angle = Math.PI*((double)arrow_head_angle)/180.0;
   
      /* final arrowhead points transformed to match the line */  
      int result1_x, result1_y, result2_x, result2_y, result3_x, result3_y;
   
      /* figure out the length of the target line */
      dx = (double)(x2-x1);
      dy = (double)(y2-y1);
      len = Math.sqrt(dx*dx+dy*dy);

      /* bail out now if its zero length (since direction is not determined) */
      if (len == 0) return;
     
      /* compute canonical arrow head points (as if on a line on x axis)
       *
       *             1
       *              \
       *   +-----------2-------0----- x axis --->
       *              /  
       *             3
       *
       * arrowhead is draw as a 4 point polygon (with pt0 at the tip)
       */

        pt1_x = len - ah_len*Math.cos(ah_angle);
      pt1_y = ah_len*Math.sin(ah_angle);
      pt2_x = len - (len-pt1_x)*arrow_inset; 
      pt2_y = 0;
      pt3_x = pt1_x;
      pt3_y = -pt1_y;
      
      /* sin and cos of rotation to get canonical from x axis to target */
      sin_theta = dy / len;
      cos_theta = dx / len;
      
      /* rotate and translate to get our final points */
      result1_x = (int)(pt1_x*cos_theta - pt1_y*sin_theta + 0.5) + x1;
      result1_y = (int)(pt1_x*sin_theta + pt1_y*cos_theta + 0.5) + y1;
      result2_x = (int)(pt2_x*cos_theta - pt2_y*sin_theta + 0.5) + x1;
      result2_y = (int)(pt2_x*sin_theta + pt2_y*cos_theta + 0.5) + y1;
      result3_x = (int)(pt3_x*cos_theta - pt3_y*sin_theta + 0.5) + x1;  
      result3_y = (int)(pt3_x*sin_theta + pt3_y*cos_theta + 0.5) + y1;
       
      /* draw the arrow head polygon */
      int xs[] = {x2, result1_x, result2_x, result3_x};
      int ys[] = {y2, result1_y, result2_y, result3_y};
       
      g.drawLine( x2, y2, result1_x, result1_y );
      g.drawLine( x2, y2, result3_x, result3_y );
         
      //fill_polygon(xs,ys,4);
    }//end draw Arrow function



      public static void clearDragged(){
      
         draggedPts.clear();

      }

      public static void setFillColors(Color newColor){

         for( int x = 0; x < Shapes.size( ); x++ ){
	    ShapeClass SC = (ShapeClass) Shapes.get( x );

	    if( SC.isSelected ){

	       SC.myFillColor = newColor;
	       System.out.println( "Set the fill color: " + newColor );
	       SC.isFilled = true;
	     
            }

	 }

      }


      public static void setOutlineColors(Color newColor){

	 for( int x = 0; x < Shapes.size( ); x++ ){

	    ShapeClass SC = (ShapeClass) Shapes.get(x);
	      
            if( SC.isSelected ){
	       SC.myOutColor = newColor;
	    }

         }

      }

      public int getTypeLine(Point p1, Point p2){

         if( p1.getX( ) > p2.getX( ) && p1.getY( ) < p2.getY( ) ){
	    return 1;
         }

         else if( p1.getX( ) > p2.getX( ) ){
            return 2;
         }

         else if( p1.getX( ) < p2.getX( ) && p1.getY( ) < p2.getY( ) ){
 	    return 3;
         }

         else{
  	    return 4;
         }

      }

/*************************************/

/*******General shape class ***********/

  public class ShapeClass{

   Point startPoint = new Point(-1, -1);
   Rectangle bottomPoint = new Rectangle(-1, -1, 0, 0);
   Rectangle topPoint = new Rectangle(-1, -1, 0, 0);
   Rectangle rightPoint = new Rectangle(-1, -1, 0, 0);
   Rectangle leftPoint = new Rectangle(-1, -1, 0, 0);


   String type = new String("none");
   Vector Points = new Vector();
   String text = new String("none");
   Color myOutColor;
   Color myFillColor;
   boolean isFilled = false;
   Rectangle SelectedBox = new Rectangle(-1,-1,0,0);
   boolean isSelected = false;
   boolean hasArrow = false;
   boolean hasArrowHead = false;
   Vector links = new Vector();
   Point arrowHead = new Point();
   int maxheight=0;
   int minheight = 100000;
   int maxwidth=0;
   int minwidth = 100000;
    BufferedImage image = new BufferedImage(1,1,BufferedImage.TYPE_INT_RGB);
    //   BufferedImage image;
    // = new BufferedImage(0,0,BufferedImage.TYPE_INT_RGB);
   QuadCurve2D quadCurve = new QuadCurve2D.Float();
   CubicCurve2D cubeCurve = new CubicCurve2D.Float();

     ShapeClass(String shape){
      type = shape;
     }
      ShapeClass( ShapeClass src )
      {
	  if( this != src )
	      {
		  startPoint = (Point)src.startPoint.clone();
		  bottomPoint = (Rectangle)src.bottomPoint.clone();
		  topPoint = (Rectangle)src.topPoint.clone();
		  rightPoint = (Rectangle)src.rightPoint.clone();
		  leftPoint = (Rectangle)src.leftPoint.clone();

		  type = src.type;
		  Points = (Vector)src.Points.clone();
		  text = src.text;
		  if( src.myOutColor != null )
		      {
			  myOutColor = new Color(src.myOutColor.getRed(),src.myOutColor.getGreen(),src.myOutColor.getBlue() );
		      }
		  if( src.myFillColor != null )
		      {
			  myFillColor = new Color(src.myFillColor.getRed(),src.myFillColor.getGreen(),src.myFillColor.getBlue() );
		      }
		  isFilled = src.isFilled;
		  SelectedBox = (Rectangle)src.SelectedBox.clone();
		  isSelected = src.isSelected;
		  hasArrow = src.hasArrow;
		  arrowHead = (Point)src.arrowHead.clone();
		  maxheight = src.maxheight;
		  minheight = src.minheight;
		  maxwidth = src.maxwidth;
		  minwidth = src.minwidth;
		  image = src.image;
		  //BufferedImage image = new BufferedImage(1,1,BufferedImage.TYPE_INT_RGB);
	      }
      }
     public String getType(){
                  return type;
     }



   public void checkFreehandPoints(Point p){

/**** in free hand stores the points for SelectedBox *******/

                 if((int)p.getX()>maxwidth)
                        maxwidth = (int)p.getX();
                 if((int)p.getX() < minwidth)
                        minwidth = (int)p.getX();

                 if((int)p.getY()>maxheight)
                        maxheight = (int)p.getY();
                 if((int)p.getY()<minheight)
                        minheight = (int)p.getY();


        }

     public void print(Graphics g){

       Point p1 = (Point) Points.get(0);

       int s = 0;
       Point p2 = new Point(s,s);
       if( Points.size( ) >= 2 ){
          p2 = (Point) Points.get( 1 );
       }


       int width = (int) (p2.getX() - p1.getX());
       int height = (int) (p2.getY() - p1.getY());

        Point pp = SelectedBox.getLocation();
	Dimension size = SelectedBox.getSize();
        int x = (int) (pp.getX() + (int)size.getWidth()/2); //(int) ((size.getWidth() + p1.getX())/2);
        int y = (int) (pp.getY() + size.getHeight() - 2); //(int) ((size.getHeight() + p1.getY())/2);
        int x2 = (int) (pp.getX() + (int) size.getWidth()/2);
        int y2 = (int) (pp.getY() - 2);

        int x3 = (int) (pp.getX() - 2);
        int y3 = (int) (pp.getY() + (int) size.getHeight()/2);
        int x4 = (int) (pp.getX() + size.getWidth() - 2);
        int y4 = (int) (pp.getY() + (int) size.getHeight()/2);
        bottomPoint = new Rectangle(x, y, 20, 20);
        topPoint = new Rectangle(x2, y2, 20, 20);
        leftPoint = new Rectangle(x3, y3, 20, 20);
        rightPoint = new Rectangle(x4, y4, 20, 20);


	if(hasArrowHead){
//		System.out.println("link: " + link.startPoint);
//		g.drawRect(x, y3, 10, 10); // middle of other shape
            /* Justin */
            // find both shapes for each link in links and find the shortest distance between two points and draw it
            int my_index = 0;
            for( my_index = 0; my_index < links.size(); my_index++ )
                {
                    if(links.elementAt(my_index)!=null)
                        {
                            Point arrowPoint = new Point(0,0);
                            Point tailPoint = new Point(0,0);
                            Point tempPoint1 = new Point(0,0);
                            Point tempPoint2 = new Point(0,0);
                            int index = 0;
                            int index2 = 0;
                            double minDistance = 10000.0;
                            double tempDistance = 10000.0;
                            Rectangle tempBox = new Rectangle( ((ShapeClass)links.elementAt(my_index)).SelectedBox );


                            for( index = 0; index < 4; index++ )
                                {
                                    if( index == 0 )
                                        {
                                            tempPoint1.setLocation( (SelectedBox.getX() + (SelectedBox.getWidth() / 2 )),
                                                                    SelectedBox.getY());
                                        }
                                    else if( index == 1 )
                                        {
                                            tempPoint1.setLocation( (SelectedBox.getX() + (SelectedBox.getWidth() / 2 )),
                                                                    (SelectedBox.getY() + SelectedBox.getHeight() ));
                                        }
                                    else if( index == 2 )
                                        {
                                            tempPoint1.setLocation( SelectedBox.getX(),
                                                                    (SelectedBox.getY() + (SelectedBox.getHeight() / 2 )));
                                        }
                                    else if( index == 3 )
                                        {
                                            tempPoint1.setLocation( (SelectedBox.getX() + SelectedBox.getWidth()),
                                                                    (SelectedBox.getY() + (SelectedBox.getHeight() / 2 )));
                                        }
                                    for( index2 = 0; index2 < 4; index2++ )
                                        {
                                            if( index2 == 0 )
                                                {
                                                    tempPoint2.setLocation( (tempBox.getX() + (tempBox.getWidth() / 2 )),
                                                                            tempBox.getY());
                                                }
                                            else if( index2 == 1 )
                                                {
                                                    tempPoint2.setLocation( (tempBox.getX() + (tempBox.getWidth() / 2 )),
                                                                            (tempBox.getY() + tempBox.getHeight() ));
                                                }
                                            else if( index2 == 2 )
                                                {
                                                    tempPoint2.setLocation( tempBox.getX(),
                                                                            (tempBox.getY() + (tempBox.getHeight() / 2 )));
                                                }
                                            else if( index2 == 3 )
                                                {
                                                    tempPoint2.setLocation( (tempBox.getX() + tempBox.getWidth()),
                                                                            (tempBox.getY() + (tempBox.getHeight() / 2 )));
                                                }

                                            tempDistance = (((Point2D)tempPoint1).distance(tempPoint2.getX(),tempPoint2.getY()));
                                            if( tempDistance < minDistance )
                                                {
                                                    arrowPoint.setLocation( tempPoint1.getX(),tempPoint1.getY() );
                                                    tailPoint.setLocation( tempPoint2.getX(), tempPoint2.getY() );
                                                    minDistance = tempDistance;
                                                }
                                        }
                                }


                            // Print line and arrowheads now
                            g.drawLine((int)arrowPoint.getX(),(int)arrowPoint.getY(),(int)tailPoint.getX(),(int)tailPoint.getY());
                            fill_arrowhead( (int)tailPoint.getX(), (int)tailPoint.getY(), (int)arrowPoint.getX(), (int)arrowPoint.getY(), 15, 30, .60, g );
                        } // ends if link == null
                }
            /* Justin */
	}

/**************************
Printing a Rectangle
**************************/

      if(type.equals("Rectangle")){
       g.setColor(myOutColor);
	g.drawRect((int)p1.getX(), (int) p1.getY(), width, height);
       if(isFilled){
       g.setColor(myFillColor);
       g.fillRect((int)p1.getX()+1, (int) p1.getY()+1, width-2, height-2);
       }
	if(isSelected){
	g.setColor(Color.black);
	g.fillRect(x4, y4, 5, 5);
	g.fillRect(x, y, 5, 5);
        g.fillRect(x2, y2, 5, 5);
	g.fillRect(x3, y3, 5, 5);
	}

	g.setColor(Color.black);
      }
/**************************
Printing a Rectangle
**************************/


/**************************
Printing an Ellipse
**************************/


      else if(type.equals("Ellipse")){
       g.setColor(myOutColor);

//        g.setColor(Color.black);
  //     System.out.println(myOutColor);
       g.drawOval((int)p1.getX(), (int) p1.getY(), width, height);
       if(isFilled){
       g.setColor(myFillColor);
       g.fillOval((int)p1.getX()+1, (int) p1.getY()+1, width-2, height-2);
       }


        if(isSelected){

      /*** for resizing purposes *****/

	g.setColor(Color.black);
	g.fillRect(x4, y4, 5, 5);
	g.fillRect(x, y, 5, 5);
        g.fillRect(x2, y2, 5, 5);
	g.fillRect(x3, y3, 5, 5);


      /*** 			*****/



        g.setColor(Color.red);
        g.drawRect((int)pp.getX(), (int) pp.getY(), (int)size.getWidth(),(int)size.getHeight());
        g.setColor(Color.black);

        }

	g.setColor(Color.black);

      }

/**************************
Printing an Ellipse
**************************/




/**************************
Printing a Line
**************************/


      else if(type.equals("Line") || type.equals("Arrow")){

       g.setColor(myOutColor);
	int t = 0;

       g.drawLine((int)p1.getX(), (int)p1.getY(), (int) p2.getX(),(int) p2.getY());

	t = getTypeLine(p1, p2);

       if(type.equals("Arrow")){

          //anshu3
          fill_arrowhead( (int)p1.getX( ), (int)p1.getY( ), (int)p2.getX( ),
                          (int)p2.getY( ), 15, 30, .60, g );
 	
       }


	g.setColor(Color.black);

	if(isSelected){
	g.fillRect(x4, y4, 5, 5);
	g.fillRect(x, y, 5, 5);
        g.fillRect(x2, y2, 5, 5);
	g.fillRect(x3, y3, 5, 5);
        g.setColor(Color.red);

	int w2 = (int) size.getWidth();
	int h2 = (int) size.getHeight();

        g.drawRect((int)pp.getX(), (int)pp.getY(), w2,h2);


        g.setColor(Color.black);

        } // done is selected

      }
/**************************
Printing a Line
**************************/


/*************************
Printing a Curved Line
*************************/
   else if( type.equals( "Curved" ) ) {

     //set color to current outline color
     g.setColor( myOutColor );

     //if 2 or 3 points have been specified for the curve
     if ( Points.size( ) == 2 ) {

        p1 = new Point( (Point)Points.get(0) );
        p2 = new Point( (Point)Points.get(1) );

        //set the curve
        quadCurve.setCurve( p1.getX( ), p1.getY( ),
                            p2.getX( ), p2.getY( ),
                            p2.getX( ), p2.getY( ) );

        ((Graphics2D)g).draw(quadCurve);

     }

     //if 2 or 3 points have been specified for the curve
     if ( Points.size( ) == 3 ) {

        p1 = new Point( (Point)Points.get(0) );
        p2 = new Point( (Point)Points.get(1) );
        Point p3 = new Point( (Point)Points.get(2) );

        //set the curve
        quadCurve.setCurve( p1.getX( ), p1.getY( ),
                               p2.getX( ), p2.getY( ),
                               p3.getX( ), p3.getY( ) );

        ((Graphics2D)g).draw(quadCurve);

     }

     //if 4 points have been specified for the curve
     if ( Points.size( ) == 4 ) {

        p1 = new Point( (Point)Points.get(0) );
        p2 = new Point( (Point)Points.get(1) );
        Point p3 = new Point( (Point)Points.get(2) );
        Point p4 = new Point( (Point)Points.get(3) );

        //set the curve
        cubeCurve.setCurve( p1.getX( ), p1.getY( ),
                               p2.getX( ), p2.getY( ),
                               p3.getX( ), p3.getY( ),
                               p4.getX( ), p4.getY( ) );

         ((Graphics2D)g).draw(cubeCurve);
     }

     //if curve has just been created or is currently selected
     if ( isSelected ) {

        g.setColor(Color.black);

        Point ctrlPt1 = new Point( (Point)Points.get(1) );
        Point ctrlPt2 = new Point( );

        Point begPt = new Point( );
        Point endPt = new Point( );

        //if it is a line
        if ( Points.size( ) == 2 ) {

           begPt = (Point)Points.get( 0 );
           endPt = (Point)Points.get( 1 );

           //set Top point
           topPoint = new Rectangle(
              (int)( ( begPt.getX( ) + endPt.getX() ) / 2 ),
              (int)( ( begPt.getY( ) + endPt.getY() ) / 2 ),
              20, 20 );

           //draw first control point
           g.fillRect(
              (int) ( ( begPt.getX( ) + endPt.getX() ) / 2 ),
              (int) ( ( begPt.getY( ) + endPt.getY() ) / 2 ),
              5, 5 );


        }

          //if it is a quadcurve
        else if ( Points.size( ) >= 3 ) {

           //set Top point
           topPoint = new Rectangle( (int)ctrlPt1.getX( ),
                                     (int)ctrlPt1.getY( ) + 2, 20, 20 );

           //draw first control point
           g.fillRect(  (int)ctrlPt1.getX( ),
                        (int)ctrlPt1.getY( ), 5, 5 );

        }

        //IF IT IS A CUBE CURVE
        if ( Points.size( ) == 4 ) {

           ctrlPt2 = (Point)Points.get(2);

           //set Bottom Point
           bottomPoint = new Rectangle( (int)ctrlPt2.getX( ),
                                        (int)ctrlPt2.getY( ), 20, 20 );

           //draw second control point
           g.fillRect( (int)ctrlPt2.getX( ), (int)ctrlPt2.getY( ), 5, 5 );

        }

	 /*Draw Points on Selection Box
        g.setColor(Color.black);
        g.fillRect(x4, y4, 5, 5);
        g.fillRect(x, y, 5, 5);
        g.fillRect(x2, y2, 5, 5);
        g.fillRect(x3, y3, 5, 5);
        */

        //Draw Selection Box
        g.setColor(Color.red);
        g.drawRect((int)pp.getX(), (int) pp.getY(), (int)size.getWidth(),(int)size.getHeight( ) );
        g.setColor(Color.black);



     }//ends If ( isSelected )


   }


//omer
/**************************
Printing Text
**************************/

      else if(type.equals("Text")){

        //anshu2
        //set text to current outline color
        g.setColor( myOutColor );

	g.drawString(text,(int)startPoint.getX(),(int)startPoint.getY());

	if(isSelected == true){
	  g.setColor(Color.red);
	  FontMetrics fm2 = g.getFontMetrics();
	  g.drawRect((int)startPoint.getX()-2, (int)startPoint.getY()-fm2.getHeight(), fm2.stringWidth(text)+2,fm2.getHeight()+4);
	  g.setColor(Color.black);
	}

      }




/**************************
Printing Poly
**************************/

      else if(type.equals("Poly")){

      if ( Points.size( ) >= 2 ) {

         int pA, pB;

         //anshu2
         //set color of line to its outline color
         g.setColor( myOutColor );


         for(pA = 0, pB = 1; pB < Points.size(); pA++, pB++){

            Point point1 = new Point( (Point)Points.get( pA ) );
            Point point2 = new Point( (Point)Points.get( pB ) );

            g.drawLine( (int)( point1.getX( ) ),
                        (int)( point1.getY( ) ),
                        (int)( point2.getX( ) ),
                        (int)( point2.getY( ) ) );
         }
      }

       if(isSelected){

         //make resizing points
         g.setColor( Color.black );
         g.fillRect(x4, y4, 5, 5);
         g.fillRect(x, y, 5, 5);
         g.fillRect(x2, y2, 5, 5);
         g.fillRect(x3, y3, 5, 5);

         //draw box
         g.setColor(Color.red);
	 g.drawRect((int)pp.getX(), (int) pp.getY(), (int)size.getWidth(),(int)size.getHeight());

         g.setColor(Color.black);
       }

      }//else if poly.



/**************************
Printing Freehand
**************************/

      else if(type.equals("Freehand")){

       g.setColor(myOutColor);

                        for(int l=0; l+1<Points.size(); l++){
                                Point p3 = (Point) Points.get(l);
                                Point p4 = (Point) Points.get(l+1);
                                g.drawLine((int)p3.getX(),(int) p3.getY(), (int) p4.getX(), (int) p4.getY());
                        }

	if(isSelected){
	g.setColor( Color.black );
	g.fillRect(x4, y4, 5, 5);
	g.fillRect(x, y, 5, 5);
        g.fillRect(x2, y2, 5, 5);
	g.fillRect(x3, y3, 5, 5);

	g.setColor(Color.red);
        g.drawRect((int)pp.getX(), (int) pp.getY(), (int)size.getWidth(),(int)size.getHeight());
        g.setColor(Color.black);
	}
	g.setColor(Color.black);


      }

      else if(type.equals("Image")){
	g.drawImage(image, (int)((Point)Points.elementAt(0)).getX(),(int)((Point)Points.elementAt(0)).getY(),owner.frame);
	if(isSelected){
	  g.setColor(Color.red);
	  g.drawRect((int)pp.getX(), (int)pp.getY(), (int)size.getWidth(),(int)size.getHeight());
	  g.setColor(Color.black);
	}
	g.setColor(Color.black);
      }


     }



/**************************
Printing Freehand
**************************/


  };

/*******DONE SHAPECLASS**************************************/



	public static void callRepaint(){
		System.out.println("call re");
//		paint(this.getGraphics());
	}


     public void boxLines(int t, int w2, int h2, ShapeClass sc){

        if( t == 1 ) {
           w2 = (int) startPoint.getX() - (int) stopPoint.getX();
           h2 = (int) stopPoint.getY() - (int) startPoint.getY();

           int xp = (int)stopPoint.getX();
           int yt = (int)startPoint.getY();
           Point t2 = new Point(xp, yt);

           int xp2 = (int)startPoint.getX();
           int yt2 = (int)stopPoint.getY();
           Point t3 = new Point(xp2, yt2);

           sc.SelectedBox.setLocation(t2);
           sc.SelectedBox.setSize(w2, h2);

        }

        else if( t == 2 ) {
           w2 = (int) startPoint.getX( ) - (int) stopPoint.getX( );
           h2 = (int) startPoint.getY( ) - (int) stopPoint.getY( );

           sc.SelectedBox.setLocation(stopPoint);
           sc.SelectedBox.setSize(w2, h2);

        }

        else if( t == 4 ){
           w2 = (int) stopPoint.getX() - (int) startPoint.getX();
           h2 = (int) startPoint.getY() - (int) stopPoint.getY();

           int xp = (int)startPoint.getX();
           int yt = (int)stopPoint.getY();
           Point t2 = new Point(xp, yt);

           int xp2 = (int)startPoint.getX();
           int yt2 = (int)stopPoint.getY();
           Point t3 = new Point(xp2, yt2);

           sc.SelectedBox.setLocation(t2);
           sc.SelectedBox.setSize(w2, h2);

       }

   }



	public void setLastCommand(String s){
	lastcommand = s;
	}


        public void setDeselected(){

	/****Sets all shapes to not be selected *****/

		for(int l=0; l<Shapes.size(); l++){
			ShapeClass SC = (ShapeClass) Shapes.get(l);
			SC.isSelected = false;

		}


	}

	public void mouseDragged( MouseEvent e ){
   
           dragged = true;
           stopPoint = new Point( -1, -1 );

           Point p = e.getPoint( );
           draggedPts.add( p );
         
           if( start == 0 )
              startPoint = e.getPoint( );

           else
              endPoint = e.getPoint( );

           start++;

           repaint( );
        }


        public void mouseMoved(MouseEvent e){}

        public void mousePressed(MouseEvent e){}

	public void mouseReleased(MouseEvent e){

           start = 0;

           stopPoint = e.getPoint();

           repaint();
           
           dragged=false;
        }

	public void mouseEntered(MouseEvent e){}

	public void mouseExited(MouseEvent e){}

	public void mouseClicked(MouseEvent e){

           e.consume();
	   Point p = e.getPoint();
           Points.add(p);

           //anshu
           if ( ( Toolbar.getCommand( ) ).equals( "Curved" ) &&
                  e.getClickCount( ) == 2 ) {

              numClicks = e.getClickCount( );

           }

	   //omer
	   if ( Toolbar.getCommand( ) == "Poly" && e.getClickCount( ) == 2) {
              numClicks = e.getClickCount( );
	   }

	   if ( Toolbar.getCommand( ) == "Select" && e.getClickCount( ) == 2) {
	       numClicks = e.getClickCount( );
	       //System.out.println("clicked 2x with select");
           }



           repaint();
	}


/******Resizing top Point********************/

      public void topPointFunction(Graphics g, ShapeClass SC, Dimension size, Point p3, int wid, int ht){
			backup();
			clean = false;

                        int x2 = (int) p3.getX();
        		int y2 = (int) p3.getY() + ht;

			int w = (int) size.getWidth();
        		int h = (int) (size.getHeight() - ht);

			int i = (int) (p3.getX() + size.getWidth());
			int i2 = (int) (p3.getY() + size.getHeight());

			Point p4 = new Point(x2, y2);
			Point p42 = new Point(i, i2);

               if(stopPoint.x==-1){

                //anshu2
                //if curved line then show ctrl box
                if ( SC.type.equals( "Curved" ) ) {
                   g.setColor(Color.blue);

                   Point tempPt = new Point( (Point)draggedPts.lastElement( ) );

                   g.fillRect( (int)tempPt.getX( ), (int)tempPt.getY( ), 5, 5 );

                }

                else {
                   g.setColor(Color.green);
                   g.drawRect(x2, y2, w, h);
                }

            } // done if stop point



		else{  // stoped stretching
/****resizes object in selected box **********/


/****Resizing Ellipse and rectangle**********************/




if(SC.type.equals("Line") || SC.type.equals("Arrow")){

        	int t = 0;
	        t = getTypeLine((Point)SC.Points.get(0), (Point)SC.Points.get(1));

        if(t==1){
			x2 = (int)((Point)SC.Points.get(1)).getX();
			y2 = (int)((Point)SC.Points.get(1)).getY();

			i = (int)((Point)SC.Points.get(0)).getX();
			i2 = (int) (((Point) SC.Points.get(0)).getY() + ht);

			p4 = new Point(x2, y2);
			p42 = new Point(i, i2);

        Point t2 = new Point(x2, i2);
        SC.SelectedBox.setLocation(t2);
			SC.Points.clear();
			SC.Points.add(p4);
			SC.Points.add(p42);

					SC.SelectedBox.setSize(w, h);
                               draggedPts.clear();


	    }

        else if(t==2){
			x2 = (int)((Point)SC.Points.get(1)).getX();
			y2 = (int)((Point)SC.Points.get(1)).getY() + ht;

			i = (int)((Point)SC.Points.get(0)).getX();
			i2 = (int) (((Point) SC.Points.get(0)).getY());

			p4 = new Point(x2, y2);
			p42 = new Point(i, i2);

        Point t2 = new Point(x2, y2);
        SC.SelectedBox.setLocation(t2);
			SC.Points.clear();
			SC.Points.add(p4);
			SC.Points.add(p42);

					SC.SelectedBox.setSize(w, h);
                               draggedPts.clear();


	    }

        else if(t==3){
			SC.Points.clear();
			SC.Points.add(p4);
			SC.Points.add(p42);
					SC.SelectedBox.setLocation(p4);
					SC.SelectedBox.setSize(w, h);
                               draggedPts.clear();


	    }


       else if(t==4){

			x2 = (int)((Point)SC.Points.get(0)).getX();
			y2 = (int)((Point)SC.Points.get(0)).getY();

			i = (int)((Point)SC.Points.get(1)).getX();
			i2 = (int) (((Point) SC.Points.get(1)).getY() + ht);

			p4 = new Point(x2, y2);
			p42 = new Point(i, i2);

        Point t2 = new Point(x2, i2);
        SC.SelectedBox.setLocation(t2);
			SC.Points.clear();
			SC.Points.add(p4);
			SC.Points.add(p42);

					SC.SelectedBox.setSize(w, h);
                               draggedPts.clear();


	    }




			}

/****Done line*******/


                        else if(SC.type.equals("Ellipse") || SC.type.equals("Rectangle") || SC.type.equals("Line")){ // resizes ellipse
			SC.Points.clear();
			SC.Points.add(p4);
			SC.Points.add(p42);
					SC.SelectedBox.setLocation(p4);
					SC.SelectedBox.setSize(w, h);
                               draggedPts.clear();

                        }

/****Resizing Ellipse**********************/

/****Resizing Curved Line**********************/
                //anshu2
                else if ( SC.type.equals("Curved") ) {
                      backup( );
                      clean = false;


                   //reset curve to new ctrl Point

                   //if it is a line
                   if ( SC.Points.size( ) == 2 ) {


                      //replace control point with new one
                      SC.Points.insertElementAt( (Point)stopPoint, 1 );

                      Point p1 = new Point( (Point)SC.Points.get( 0 ) );
                      Point p2 = new Point( (Point)SC.Points.get( 1 ) );
                      Point p5 = new Point( (Point)SC.Points.get(2) );


                      //set the curve
                      SC.quadCurve.setCurve( p1.getX( ), p1.getY( ),
                                             p2.getX( ), p2.getY( ),
                                             p5.getX( ), p5.getY( ) );

                      //set selection box
                      SC.SelectedBox = SC.quadCurve.getBounds( );

                   }

                   //if it is a quadCurve
                   else if ( SC.Points.size( ) == 3 ) {

                      //replace control point with new one
                      SC.Points.setElementAt( (Point)stopPoint, 1 );

                      Point p1 = new Point( (Point)SC.Points.get( 0 ) );
                      Point p2 = new Point( (Point)SC.Points.get( 1 ) );
                      Point p5 = new Point( (Point)SC.Points.get(2) );


                      //set the curve
                      SC.quadCurve.setCurve( p1.getX( ), p1.getY( ),
                                             p2.getX( ), p2.getY( ),
                                             p5.getX( ), p5.getY( ) );

                      //set selection box
                      SC.SelectedBox = SC.quadCurve.getBounds( );

                   }

		     //if it is a cubeCurve
                   else if ( SC.Points.size( ) == 4 ) {

                      //replace control point with new one
                      SC.Points.setElementAt( (Point)stopPoint, 1 );

                      Point p1 = new Point( (Point)SC.Points.get( 0 ) );
                      Point p2 = new Point( (Point)SC.Points.get( 1 ) );
                      Point p5 = new Point( (Point)SC.Points.get( 2 ) );
                      Point p6 = new Point( (Point)SC.Points.get( 3 ) );

                      //set the curve
                      SC.cubeCurve.setCurve( p1.getX( ), p1.getY( ),
                                             p2.getX( ), p2.getY( ),
                                             p5.getX( ), p5.getY( ),
                                             p6.getX( ), p6.getY( ) );

                      //set selection box
                      SC.SelectedBox = SC.cubeCurve.getBounds( );

                   }

                   draggedPts.clear( );

                }

/****Resizing Freehand**********************/

        else if(SC.type.equals("Freehand") || SC.type.equals("Poly")){ // resizes freehand
        //% change due to drag...use 1 - etc because of how xy coords work
                          float mult = 1 - (float)(ht)/(float)size.getHeight();
                          //base movement off of
                          int base = (int)p3.getY() + (int)size.getHeight();

                          Vector helper = new Vector();
                          for (int ii = 0; ii < (int)SC.Points.size(); ii++){
                            Point temp = (Point)SC.Points.elementAt(ii);
                            int oldY = (int)temp.getY();
                            int dist = (int) ((base - oldY) * mult);
                            helper.add(new Point((int)temp.getX(), base - dist));
                          }

			  SC.Points.clear();
			  SC.Points = (Vector)helper.clone();
			  SC.SelectedBox.setLocation(p4);
			  SC.SelectedBox.setSize(w, h);
			  draggedPts.clear();
        }


/****Resizing Freehand**********************/



        	} // ends if stop point = -1



				g.setColor(Color.black);



      }

/******Resizing top Point********************/


/******Resizing bottom Point********************/

      public void bottomPointFunction(Graphics g, ShapeClass SC, Dimension size, Point p3, int wid, int ht){
			backup();
			clean=false;
		        int x3 = (int) p3.getX();
        		int y3 = (int) p3.getY();

			int w2 = (int) size.getWidth();
        		int h2 = (int) (size.getHeight() + ht);
		      int pty = y3 + h2;
 			int ptx = x3 + w2;

			Point p52 = new Point(ptx, pty);

	  if(SC.type != "Text"){

	   if(stopPoint.x==-1){

              //anshu2
              if ( SC.type.equals( "Curved" ) ) {
                   g.setColor(Color.blue);

                   Point tempPt = new Point( (Point)draggedPts.lastElement( ) );

                   g.fillRect( (int)tempPt.getX( ), (int)tempPt.getY( ), 5, 5 );

                }


               else {
                    g.setColor(Color.green);
                    g.drawRect(x3, y3, w2, h2);

               }

            } // done if stop point


		else{  // stoped stretching
			Point p5 = new Point(x3, y3);



/****Resizing line***********************/

if(SC.type.equals("Line") || SC.type.equals("Arrow")){

        	int t = 0;
	        t = getTypeLine((Point)SC.Points.get(0), (Point)SC.Points.get(1));

        if(t==1){

			x3 = (int)((Point)SC.Points.get(0)).getX();
			y3 = (int)((Point)SC.Points.get(0)).getY();

			int i = (int)((Point)SC.Points.get(1)).getX();
			int i2 = (int) (((Point) SC.Points.get(1)).getY() + ht);

			p5 = new Point(x3, y3);
			p52 = new Point(i, i2);

        Point t2 = new Point(i, y3);
        SC.SelectedBox.setLocation(t2);
			SC.Points.clear();
			SC.Points.add(p5);
			SC.Points.add(p52);
					SC.SelectedBox.setSize(w2, h2);
                               draggedPts.clear();

	    }


        else if(t==2){
			x3 = (int)((Point)SC.Points.get(1)).getX();
			y3 = (int)((Point)SC.Points.get(1)).getY();

			int i = (int)((Point)SC.Points.get(0)).getX();
			int i2 = (int) (((Point) SC.Points.get(0)).getY()) + ht;

			p5 = new Point(x3, y3);
			p52 = new Point(i, i2);

        Point t2 = new Point(x3, y3);
        SC.SelectedBox.setLocation(t2);
			SC.Points.clear();
			SC.Points.add(p5);
			SC.Points.add(p52);

					SC.SelectedBox.setSize(w2, h2);
                               draggedPts.clear();


	    }
        else if(t==3){
			SC.Points.clear();
			SC.Points.add(p5);
			SC.Points.add(p52);
			SC.SelectedBox.setLocation(p5);
			SC.SelectedBox.setSize(w2, h2);
                        draggedPts.clear();


	    }
       else if(t==4){

			x3 = (int)((Point)SC.Points.get(0)).getX();
			y3 = (int)((Point)SC.Points.get(0)).getY()+ht;

			int i = (int)((Point)SC.Points.get(1)).getX();
			int i2 = (int) (((Point) SC.Points.get(1)).getY());

			p5 = new Point(x3, y3);
			p52 = new Point(i, i2);

        Point t2 = new Point(x3, i2);
        SC.SelectedBox.setLocation(t2);
			SC.Points.clear();
			SC.Points.add(p5);
			SC.Points.add(p52);
					SC.SelectedBox.setSize(w2, h2);
                               draggedPts.clear();

	    }


			}

/****Resizing line***********************/

//anshu2
/****Resizing Curved line***********************/
                if( SC.type.equals("Curved") ) {

                      backup( );
                      clean = false;

                      //if it is a cubeCurve
                      if ( SC.Points.size( ) == 4 ) {

                      //replace control point with new one
                      SC.Points.setElementAt( (Point)stopPoint, 2 );

                      Point p1 = new Point( (Point)SC.Points.get( 0 ) );
                      Point p2 = new Point( (Point)SC.Points.get( 1 ) );
                      Point p7 = new Point( (Point)SC.Points.get( 2 ) );
                      Point p6 = new Point( (Point)SC.Points.get( 3 ) );

                      //set the curve
                      SC.cubeCurve.setCurve( p1.getX( ), p1.getY( ),
                                             p2.getX( ), p2.getY( ),
                                             p7.getX( ), p7.getY( ),
                                             p6.getX( ), p6.getY( ) );

                      //set selection box
                      SC.SelectedBox = SC.cubeCurve.getBounds( );

                      }

                      draggedPts.clear( );

                }

                if(SC.type.equals("Ellipse") || SC.type.equals("Rectangle")){ // resizes ellipse

			SC.Points.clear();
			SC.Points.add(p5);
			SC.Points.add(p52);
			SC.SelectedBox.setLocation(p5);
			SC.SelectedBox.setSize(w2, h2);
                        draggedPts.clear();

                        }

                else if(SC.type.equals("Freehand") || SC.type.equals("Poly")){ // resizes freehand
                           //% change due to drag...use 1 - etc because of how xy coords work
                           float mult = 1 + (float)(ht)/(float)size.getHeight();
                           //base movement off of
                           int base = (int)p3.getY();

                           Vector helper = new Vector();
                           for (int ii = 0; ii < (int)SC.Points.size(); ii++){
                               Point temp = (Point)SC.Points.elementAt(ii);
                               int oldY = (int)temp.getY();
                               int dist = (int) ((oldY - base) * mult);
                               helper.add(new Point((int)temp.getX(), base + dist));
                           }

                           SC.Points.clear();
                           SC.Points = (Vector)helper.clone();
                           SC.SelectedBox.setLocation(p5);
                           SC.SelectedBox.setSize(w2, h2);
                           draggedPts.clear();

                } //ends else

		}
	  }
				g.setColor(Color.black);





      }

/********Bottom Point function done*************/

/******Resizing right Point********************/

      public void rightPointFunction(Graphics g, ShapeClass SC, Dimension size, Point p3, int wid, int ht){
			backup();
			clean=false;

		        int x4 = (int) p3.getX();
        		int y4 = (int) p3.getY();

			int w3 = (int) size.getWidth() + wid;
        		int h3 = (int) size.getHeight();
                      int pty = y4 + h3;
                        int ptx = x4 + w3;

                        Point p62 = new Point(ptx, pty);

if(SC.type != "Text"){
           if(stopPoint.x==-1){



		                g.setColor(Color.green);
		                g.drawRect(x4, y4, w3, h3);

		} // done if stop point

		else{  // stoped stretching
			Point p6 = new Point(x4, y4);

if(SC.type.equals("Line") || SC.type.equals("Arrow")){

        	int t = 0;
	        t = getTypeLine((Point)SC.Points.get(0), (Point)SC.Points.get(1));

        if(t==1){
			x4 = (int)((Point)SC.Points.get(0)).getX() + wid;
			y4 = (int)((Point)SC.Points.get(0)).getY();

			int i = (int)((Point)SC.Points.get(1)).getX();
			int i2 = (int) (((Point) SC.Points.get(1)).getY());

			p6 = new Point(x4, y4);
			p62 = new Point(i, i2);

        Point t2 = new Point(i, y4);
        SC.SelectedBox.setLocation(t2);

			SC.Points.clear();
			SC.Points.add(p6);
			SC.Points.add(p62);
					SC.SelectedBox.setSize(w3, h3);
                               draggedPts.clear();


	    }


        else if(t==2){
			x4 = (int)((Point)SC.Points.get(1)).getX();
			y4 = (int)((Point)SC.Points.get(1)).getY();

			int i = (int)((Point)SC.Points.get(0)).getX() + wid;
			int i2 = (int) (((Point) SC.Points.get(0)).getY());

			p6 = new Point(x4, y4);
			p62 = new Point(i, i2);

        Point t2 = new Point(x4, y4);
        SC.SelectedBox.setLocation(t2);
			SC.Points.clear();
			SC.Points.add(p6);
			SC.Points.add(p62);

					SC.SelectedBox.setSize(w3, h3);
                               draggedPts.clear();

	    }
        else if(t==3){
			SC.Points.clear();
			SC.Points.add(p6);
			SC.Points.add(p62);
                        		SC.SelectedBox.setLocation(p6);
					SC.SelectedBox.setSize(w3, h3);
                                        draggedPts.clear();


	    }
       else if(t==4){
			x4 = (int)((Point)SC.Points.get(0)).getX();
			y4 = (int)((Point)SC.Points.get(0)).getY();

			int i = (int)((Point)SC.Points.get(1)).getX() + wid;
			int i2 = (int) (((Point) SC.Points.get(1)).getY());

			p6 = new Point(x4, y4);
			p62 = new Point(i, i2);

        Point t2 = new Point(x4, i2);
        SC.SelectedBox.setLocation(t2);

			SC.Points.clear();
			SC.Points.add(p6);
			SC.Points.add(p62);
					SC.SelectedBox.setSize(w3, h3);
                               draggedPts.clear();


	    }


			}

                if(SC.type.equals("Ellipse") || SC.type.equals("Rectangle")){ // resizes ellipse

			SC.Points.clear();
                        SC.Points.add(p6);
                        SC.Points.add(p62);
                        		SC.SelectedBox.setLocation(p6);
					SC.SelectedBox.setSize(w3, h3);
                                        draggedPts.clear();

              }



              else if(SC.type.equals("Freehand") || SC.type.equals("Poly")){ // resizes freehand
                   //% change due to drag...use 1 - etc because of how xy coords work
                   float mult = 1 + (float)(wid)/(float)size.getWidth();
                   //base movement off of
                   int base = (int)p3.getX();

                   Vector helper = new Vector();
                   for (int ii = 0; ii < (int)SC.Points.size(); ii++){
                       Point temp = (Point)SC.Points.elementAt(ii);
                       int oldX = (int)temp.getX();
                       int dist = (int) ((oldX - base) * mult);
                       helper.add(new Point(base + dist, (int)temp.getY()));
                   }

                   SC.Points.clear();
                   SC.Points = (Vector)helper.clone();
                   SC.SelectedBox.setLocation(p6);
                   SC.SelectedBox.setSize(w3, h3);
                   draggedPts.clear();
              }





		}
}
				g.setColor(Color.black);



      }


/****** rightPoint function done********************/

/******Resizing left Point********************/

      public void leftPointFunction(Graphics g, ShapeClass SC, Dimension size, Point p3, int wid, int ht){
			backup();
			clean=false;

		        int x5 = (int) p3.getX() + wid;
        		int y5 = (int) p3.getY();

			int w4 = (int) size.getWidth() - wid;
        		int h4 = (int) size.getHeight();




                      int pty = y5 + h4;
                        int ptx = x5 + w4;

                        Point p72 = new Point(ptx, pty);

	if(SC.type != "Text"){
          if(stopPoint.x==-1){
		                g.setColor(Color.green);
		                g.drawRect(x5, y5, w4, h4);

		} // done if stop point
		else{  // stoped stretching
			Point p7 = new Point(x5, y5);

if(SC.type.equals("Line") || SC.type.equals("Arrow")){

        	int t = 0;
	        t = getTypeLine((Point)SC.Points.get(0), (Point)SC.Points.get(1));

        if(t==1){
			x5 = (int)((Point)SC.Points.get(0)).getX();
			y5 = (int)((Point)SC.Points.get(0)).getY();

			int i = (int)((Point)SC.Points.get(1)).getX() + wid;
			int i2 = (int) (((Point) SC.Points.get(1)).getY());

			p7 = new Point(x5, y5);
			p72 = new Point(i, i2);

        Point t2 = new Point(i, y5);
        SC.SelectedBox.setLocation(t2);

			SC.Points.clear();
			SC.Points.add(p7);
			SC.Points.add(p72);
					SC.SelectedBox.setSize(w4, h4);
                               draggedPts.clear();



	    }
        else if(t==2){
			x5 = (int)((Point)SC.Points.get(1)).getX() + wid;
			y5 = (int)((Point)SC.Points.get(1)).getY();

			int i = (int)((Point)SC.Points.get(0)).getX();
			int i2 = (int) (((Point) SC.Points.get(0)).getY());

			p7 = new Point(x5, y5);
			p72 = new Point(i, i2);

        Point t2 = new Point(x5, y5);
        SC.SelectedBox.setLocation(t2);
			SC.Points.clear();
			SC.Points.add(p7);
			SC.Points.add(p72);

					SC.SelectedBox.setSize(w4, h4);
                               draggedPts.clear();


	    }
        else if(t==3){
			SC.Points.clear();
			SC.Points.add(p7);
			SC.Points.add(p72);
                        		SC.SelectedBox.setLocation(p7);
					SC.SelectedBox.setSize(w4, h4);
                                        draggedPts.clear();

	    }
       else if(t==4){
			x5 = (int)((Point)SC.Points.get(0)).getX() + wid;
			y5 = (int)((Point)SC.Points.get(0)).getY();

			int i = (int)((Point)SC.Points.get(1)).getX();
			int i2 = (int) (((Point) SC.Points.get(1)).getY());

			p7 = new Point(x5, y5);
			p72 = new Point(i, i2);

        Point t2 = new Point(x5, i2);
        SC.SelectedBox.setLocation(t2);

			SC.Points.clear();
			SC.Points.add(p7);
			SC.Points.add(p72);
					SC.SelectedBox.setSize(w4, h4);
                               draggedPts.clear();



	    }


			}

                if(SC.type.equals("Ellipse") || SC.type.equals("Rectangle")){ // resizes ellipse

			SC.Points.clear();
                        SC.Points.add(p7);
                        SC.Points.add(p72);
                        		SC.SelectedBox.setLocation(p7);
					SC.SelectedBox.setSize(w4, h4);
                                        draggedPts.clear();

              }




              else if(SC.type.equals("Freehand") || SC.type.equals("Poly")){ // resizes freehand
                   //% change due to drag...use 1 - etc because of how xy coords work
                   float mult = 1 - (float)(wid)/(float)size.getWidth();
                   //base movement off of
                   int base = (int)p3.getX() + (int)size.getWidth();

                   Vector helper = new Vector();
                   for (int ii = 0; ii < (int)SC.Points.size(); ii++){
                       Point temp = (Point)SC.Points.elementAt(ii);
                       int oldX = (int)temp.getX();
                       int dist = (int) ((base - oldX) * mult);
                       helper.add(new Point(base - dist, (int)temp.getY()));
                   }

                   SC.Points.clear();
                   SC.Points = (Vector)helper.clone();
                   SC.SelectedBox.setLocation(p7);
                   SC.SelectedBox.setSize(w4, h4);
                   draggedPts.clear();
              }



		}

	}
				g.setColor(Color.black);



      }


/****** leftPoint function done********************/


   public void selectFunction(Graphics g){

      /**** When select is the command, this is called *****/

      Point p = new Point(-1, -1);

      if( Points.size( ) > 0 || draggedPts.size( ) > 2 ){
  
         if( Points.size( ) > 0 ){

            p = (Point) Points.get( 0 );
	    Points.clear();
         }


	 boolean moved = false;

         for( int x = Shapes.size( ) - 1; x >= 0; x-- ){

            ShapeClass SC = (ShapeClass) Shapes.get(x);

	    Point p3 = SC.SelectedBox.getLocation();

	    Dimension size = SC.SelectedBox.getSize();

            int wid = (int) ( endPoint.getX( ) - startPoint.getX( ) );
            int ht = (int) ( endPoint.getY( ) - startPoint.getY( ) );

            if(SC.topPoint.contains(startPoint) && SC.isSelected && !SC.type.equals("Text")){
               backup();
               topPointFunction(g, SC, size, p3, wid, ht);
            }

            else if(SC.bottomPoint.contains(startPoint) && SC.isSelected && !SC.type.equals("Text")){
               bottomPointFunction(g, SC, size, p3, wid, ht);
	    }

            else if(SC.rightPoint.contains(startPoint) && SC.isSelected && !SC.type.equals("Text")){
               rightPointFunction(g, SC, size, p3, wid, ht);
	    }

            else if(SC.leftPoint.contains(startPoint) && SC.isSelected && !SC.type.equals("Text")){
               leftPointFunction(g, SC, size, p3, wid, ht);
            }

            /*** only selecting or deselecting******/

	    //object has been moved
            else if(draggedPts.size()>1 && SC.SelectedBox.contains(startPoint) && SC.isSelected){
           	
	     if(stopPoint.x!=-1){
	       Point tempPoint = stopPoint;
               moveFunction(SC, tempPoint, size, g);
	       stopPoint = new Point(-1, -1);
	       draggedPts.clear();
	     }

	     else{
		if(!moved)
		liveMoveFunction(SC, endPoint, size, g);
		moved = true;
	     }


            }

            else if( SC.SelectedBox.contains( p ) ){

	       
	       if(SC.isSelected)
	          SC.isSelected = false;

	       else
  	          SC.isSelected = true;

	       //omer 30
               if(SC.type.equals("Text") && numClicks == 2){
                   System.out.println("selecdtd text with 2 clicks");

                   String old_text = SC.text;
                   System.out.println(old_text);
                   try{
                       Object[] options = { "Ok", "CANCEL" };
                       Object input = JOptionPane.showInputDialog(this,"Enter new string:","Edit String",JOptionPane.PLAIN_MESSAGE,null,null,old_text);

                       if(input != null){
                           SC.text = (String)input;
                           numClicks = 0;
                           repaint();
                       }
                       numClicks= 0;

                   } catch(NullPointerException e){
                       System.out.println("User cancelled input!");
                   }
               }

               //omer 30


               break;
            }

         }  // ends for

      } // ends if

   } // ends selectFunction


     public ShapeClass getCollision(Point sp, ShapeClass SC){
            ShapeClass Sc = new ShapeClass("none");
                boolean check = true;
                int ind = Shapes.indexOf(SC);
                for(int x=0; x<Shapes.size() && check; x++){
                      if(x!=ind){   // not same shape
                 Sc = (ShapeClass) Shapes.get(x);
                  if(Sc.SelectedBox.contains(sp))
                         check = false;

                      }
                }
                              return Sc;

      }



/*********Prints all shapes****************************************/

        public void printShapes(Graphics g){

                 for(int l=0; l<Shapes.size(); l++){
                     ShapeClass SC = (ShapeClass) Shapes.get(l);
                     SC.print(g);
               }

        }


/*********Prints all shapes****************************************/

      public boolean checkCollision(Point sp, ShapeClass SC){
	

                boolean check = true;
                int ind = Shapes.indexOf(SC);
                for(int x=0; x<Shapes.size() && check; x++){
                      if(x!=ind){   // not same shape
                 ShapeClass Sc = (ShapeClass) Shapes.get(x);
                  if(Sc.SelectedBox.contains(sp))
                         check = false;

                      }
                }
                if(check)
                        return false;
                        else
                        return true;

      }

        public void liveMoveFunction(ShapeClass SC, Point sp, Dimension size, Graphics g){
		backup();
		//o 21
		Font thisFont;
		thisFont = new Font("Arial", Font.PLAIN, 20);
		g.setFont(thisFont);
		//o 21
		clean = false;
                            int wid = (int) (sp.getX() - startPoint.getX());
                            int ht = (int) (sp.getY() -startPoint.getY());

                int x = (int)sp.getX()-((int)size.getWidth()/2);  // so it will be centered
		int y = (int)sp.getY()-((int)size.getHeight()/2);// so it will be centered

		int x2 = x + (int)size.getWidth();
		int y2 = y + (int)size.getHeight();
		Point p1 = new Point(x, y);
		Point p2 = new Point(x2, y2);
		g.setColor(Color.green);

	    if(SC.type.equals("Ellipse")){
		g.drawOval((int)p1.getX(),(int)p1.getY(),(int) size.getWidth(), (int)size.getHeight());			

	    }
	    else if(SC.type.equals("Rectangle")){
		g.drawRect((int)p1.getX(),(int)p1.getY(),(int) size.getWidth(),(int)size.getHeight());			
	    }
	    else if(SC.type.equals("Line") || SC.type.equals("Arrow")){
	int t = getTypeLine((Point) SC.Points.get(0), (Point) SC.Points.get(1));

        if(t==1){
		p1 = new Point(x2, y);
		p2 = new Point(x, y2);
	       g.drawLine((int)p1.getX(), (int)p1.getY(),(int) p2.getX(),(int) p2.getY());
		if(SC.type.equals("Arrow"))
			drawArrowDownLeft(g, p2);
	    }

        else if(t==2){
	       g.drawLine((int)p1.getX(), (int)p1.getY(),(int) p2.getX(),(int) p2.getY());
		if(SC.type.equals("Arrow"))
			drawArrowUpLeft(g, p1);

	    }
	else if(t==3){
	       g.drawLine((int)p1.getX(),(int)p1.getY(),(int) p2.getX(),(int) p2.getY());
	
	if(SC.type.equals("Arrow"))
			drawArrowDownRight(g, p2);

	}

        else if(t==4){

		p1 = new Point(x, y2);

		p2 = new Point(x2, y);
	
	       g.drawLine((int)p1.getX(),(int)p1.getY(),(int) p2.getX(),(int) p2.getY());
//		       g.drawLine((int)p2.getX(),(int)p1.getY(),(int) p1.getX(),(int) p2.getY());
		if(SC.type.equals("Arrow"))
			drawArrowUpRight(g, p2);

        }
	    

	    }



	    else if(SC.type.equals("Freehand") || SC.type.equals("Poly")){

			        Vector pts2 = (Vector)SC.Points.clone();
			        Vector pts3 = new Vector();
		int ind = 0;

		for(int r=0; r<pts2.size(); r++){
		 int t=(int)(SC).SelectedBox.getLocation().getX();
		 int v=(int)(SC).SelectedBox.getLocation().getY();
		int l2 =((int) ((Point) pts2.get(r)).getX()) + (x-t);
		int p = ((int)((Point) pts2.get(r)).getY()) + (y-v);
		pts3.add(new Point(l2, p));

		}

			 for(int l=0; l+1<pts3.size(); l++){
                                Point p3 = (Point) pts3.get(l);
                                Point p4 = (Point) pts3.get(l+1);
				g.drawLine((int)p3.getX(),(int) p3.getY(),(int)p4.getX(), (int)p4.getY());
                        }

		} //ends freehand



	    else if(SC.type.equals("Text")){	
		g.drawString(SC.text,(int)p1.getX(),(int)p1.getY());
		}


        else if ( SC.type.equals("Curved") ) {

           int PointSize = SC.Points.size( );

		Vector tempPoints = (Vector)SC.Points.clone();

           //adjust the points in the Points Vector of the shape to be moved
           for ( int i = 0; i < PointSize; i++ ) {

              //old point
              Point oldPt = (Point)tempPoints.remove( i );

              //new point
              Point newPt = new Point( (int)oldPt.getX( ) + wid,
                                       (int)oldPt.getY( ) + ht );

              //insert it into the points array
              tempPoints.insertElementAt( newPt, i );
           }

           //set curves based on new points

	   Point pA = new Point(-1, -1);
	   Point pB = new Point(-1, -1);
	   Point p3 = new Point(-1, -1);

if(tempPoints.size()>2){
           pA = new Point( (Point)tempPoints.get( 0 ) );
           pB = new Point( (Point)tempPoints.get( 1 ) );
           p3 = new Point( (Point)tempPoints.get(2) );
}

           //if 3 points have been specified for the curve


     if ( tempPoints.size( ) == 2 ) {

        p1 = new Point( (Point)tempPoints.get(0) );
        p2 = new Point( (Point)tempPoints.get(1) );

        //set the curve
        SC.quadCurve.setCurve( p1.getX( ), p1.getY( ),
                            p2.getX( ), p2.getY( ),
                            p2.getX( ), p2.getY( ) );

        ((Graphics2D)g).draw(SC.quadCurve);

     }


System.out.println("b4");
           if ( tempPoints.size( ) == 3 ) {
System.out.println("3");

              //set the curve
              SC.quadCurve.setCurve( pA.getX( ), pA.getY( ),
                                     pB.getX( ), pB.getY( ),
                                     p3.getX( ), p3.getY( ) );

	        ((Graphics2D)g).draw(SC.quadCurve);

              //set selection box
           }

           //if 4 points have been specified for the curve
          if ( tempPoints.size( ) == 4 ) {
System.out.println("4");

             Point p4 = new Point( (Point)tempPoints.get(3) );

             //set the curve
             SC.cubeCurve.setCurve( pA.getX( ), pA.getY( ),
                                    pB.getX( ), pB.getY( ),
                                    p3.getX( ), p3.getY( ),
                                    p4.getX( ), p4.getY( ) );

	        ((Graphics2D)g).draw(SC.cubeCurve);

          }

        }//ends if "Curved"

		g.setColor(Color.black);


	}

        public void moveFunction(ShapeClass SC, Point sp, Dimension size, Graphics g){
		backup();
		//o 21
		Font thisFont;
		thisFont = new Font("Arial", Font.PLAIN, 20);
		g.setFont(thisFont);
		//o 21
		clean = false;
                            int wid = (int) (sp.getX() - startPoint.getX());
                            int ht = (int) (sp.getY() -startPoint.getY());




/*****Collision***************************/

        if( isFixed && checkCollision(sp, SC)){


                            ShapeClass sc2 = getCollision(sp, SC);
	if((SC.type.equals("Rectangle") || SC.type.equals("Ellipse") || SC.type.equals("Text")) && (sc2.type.equals("Rectangle") || sc2.type.equals("Ellipse") || sc2.type.equals("Text"))){

			SC.hasArrow = true;
			sc2.hasArrow = true;
			sc2.hasArrowHead = true;
			sc2.links.add(SC);
			/* Justin */
			backup();
			/* Justin */
	


                return;
	}


               }

/*****Collision****************************/

                int x = (int)sp.getX()-((int)size.getWidth()/2);  // so it will be centered
		int y = (int)sp.getY()-((int)size.getHeight()/2);// so it will be centered

		int x2 = x + (int)size.getWidth();
		int y2 = y + (int)size.getHeight();
		Point p1 = new Point(x, y);
		Point p2 = new Point(x2, y2);


if(SC.type.equals("Line") || SC.type.equals("Arrow")){

        	int t = 0;
	        t = getTypeLine((Point)SC.Points.get(0), (Point)SC.Points.get(1));

        if(t==1){

		p1 = new Point(x2, y);
		p2 = new Point(x, y2);

		SC.Points.clear();
		SC.Points.add(p1);
		SC.Points.add(p2);
		SC.SelectedBox = new Rectangle(x, y, (int)size.getWidth(), (int)size.getHeight());


	    }

        else if(t==2){
		//p1 = new Point(x, y2);
		//p2 = new Point(x2, y);

		SC.Points.clear();
		SC.Points.add(p2);
		SC.Points.add(p1);
		SC.SelectedBox = new Rectangle(x, y, (int)size.getWidth(), (int)size.getHeight());



	    }
        else if(t==3){
		SC.Points.clear();
		SC.Points.add(p1);
		SC.Points.add(p2);
		SC.SelectedBox = new Rectangle(x, y, (int)size.getWidth(), (int)size.getHeight());

	    }
        else if(t==4){
		p1 = new Point(x, y2);
		p2 = new Point(x2, y);

		SC.Points.clear();
		SC.Points.add(p1);
		SC.Points.add(p2);
		SC.SelectedBox = new Rectangle(x, y, (int)size.getWidth(), (int)size.getHeight());


	    }

}
	 //anshu
        else if ( SC.type.equals("Curved") ) {

           int PointSize = SC.Points.size( );

           //adjust the points in the Points Vector of the shape to be moved
           for ( int i = 0; i < PointSize; i++ ) {

              //old point
              Point oldPt = (Point)SC.Points.remove( i );

              //new point
              Point newPt = new Point( (int)oldPt.getX( ) + wid,
                                       (int)oldPt.getY( ) + ht );

              //insert it into the points array
              SC.Points.insertElementAt( newPt, i );
           }

           //set curves based on new points
	   
	   Point pA = new Point(-1, -1);
	   Point pB = new Point(-1, -1);
	   Point p3 = new Point(-1, -1);

	if(PointSize>2){
           pA = new Point( (Point)SC.Points.get( 0 ) );
           pB = new Point( (Point)SC.Points.get( 1 ) );
            p3 = new Point( (Point)SC.Points.get(2) );
	}


     if ( PointSize== 2 ) {

        p1 = new Point( (Point)SC.Points.get(0) );
        p2 = new Point( (Point)SC.Points.get(1) );

        //set the curve
        SC.quadCurve.setCurve( p1.getX( ), p1.getY( ),
                            p2.getX( ), p2.getY( ),
                            p2.getX( ), p2.getY( ) );

        ((Graphics2D)g).draw(SC.quadCurve);
              SC.SelectedBox = SC.quadCurve.getBounds( );

     }

           //if 3 points have been specified for the curve
           if ( SC.Points.size( ) == 3 ) {

              //set the curve
              SC.quadCurve.setCurve( pA.getX( ), pA.getY( ),
                                     pB.getX( ), pB.getY( ),
                                     p3.getX( ), p3.getY( ) );

              //set selection box
              SC.SelectedBox = SC.quadCurve.getBounds( );
           }

           //if 4 points have been specified for the curve
          if ( SC.Points.size( ) == 4 ) {

             Point p4 = new Point( (Point)SC.Points.get(3) );

             //set the curve
             SC.cubeCurve.setCurve( pA.getX( ), pA.getY( ),
                                    pB.getX( ), pB.getY( ),
                                    p3.getX( ), p3.getY( ),
                                    p4.getX( ), p4.getY( ) );

             //set selection box
             SC.SelectedBox = SC.cubeCurve.getBounds( );

          }

        }//ends if "Curved"


	    else if(SC.type.equals("Ellipse") || SC.type.equals("Rectangle")){
		// since Ellipse and Line takes two points when drawing

		SC.Points.clear();
		SC.Points.add(p1);
		SC.Points.add(p2);
		SC.SelectedBox = new Rectangle(x, y, (int)size.getWidth(), (int)size.getHeight());
	    }



//omer
 else if(SC.type.equals("Text")){
   backup();
   //clean= false;
   draggedPts.clear();
   SC.Points.clear();
   SC.Points.add(p1);
   SC.Points.add(p2);
   SC.startPoint=p1;
   //o 21
   //Font thisFont;
   //thisFont = new Font("Arial", Font.PLAIN, 20);
   //g.setFont(thisFont);
   //o 21
   FontMetrics fm2 = g.getFontMetrics();
   SC.SelectedBox = new Rectangle(x, y, (int)fm2.stringWidth(SC.text)+2, 20);
   SC.SelectedBox.setLocation((int)p1.getX()-0,(int)p1.getY()-fm2.getHeight());
   //System.out.println("in move text functions");


 }

    //omer

	    else if(SC.type.equals("Freehand") || SC.type.equals("Poly")){
		// since Ellipse and Line takes two points when drawing
		draggedPts.clear(); // new
	        Vector pts2 = (Vector)SC.Points.clone();
		SC.Points.clear();
		int ind = 0;

		for(int r=0; r<pts2.size(); r++){

	 int t=(int)(SC).SelectedBox.getLocation().getX();
	 int v=(int)(SC).SelectedBox.getLocation().getY();

		int l =((int) ((Point) pts2.get(r)).getX()) + (x-t);
		int p = ((int)((Point) pts2.get(r)).getY()) + (y-v);
		SC.Points.add(new Point(l, p));

		}

		SC.SelectedBox = new Rectangle(x, y, (int)size.getWidth(), (int)size.getHeight());

	}

 else if(SC.type.equals("Image")){
   int deltX = (int)(stopPoint.getX() - startPoint.getX());
   int deltY = (int)(stopPoint.getY() - startPoint.getY());
    System.err.println(deltX + ":::" + deltY);

    Point one = (Point)SC.Points.elementAt(0);
    Point two = (Point)SC.Points.elementAt(1);
    SC.Points.clear();

    SC.Points.add(new Point((int)(one.getX() + deltX), (int)(one.getY() + deltY)));
    SC.Points.add(new Point((int)(two.getX() + deltX), (int)(two.getY() + deltY)));

    SC.SelectedBox.setLocation((int)(one.getX() + deltX), (int)(one.getY() + deltY));
}


        }




        public void paint(Graphics g){
        //o 22

	    Font thisFont;
	    thisFont = new Font("Arial", Font.PLAIN, 20);
	    g.setFont(thisFont);
	    //o 21
	    super.paint(g);
            paint2(g);

            repaintMenus();
        }

        // Repaints file menu, edit menu and menu bar depending on which one is visible
        void repaintMenus()
        {
            if (fileMenu.isPopupMenuVisible())
            {
              fileNew.repaint();
              fileOpen.repaint();
              fileSave.repaint();
              fileSaveAs.repaint();
              filePrint.repaint();
              fileClose.repaint();
              fileExit.repaint();
            }
            else if (editMenu.isPopupMenuVisible())
            {
              editUndo.repaint();
              editCopy.repaint();
              editPaste.repaint();
              editDelete.repaint();
              editSendToBack.repaint();
              editBringToFront.repaint();
              selectAll.repaint();
	      unselectAll.repaint();
            }
            menuBar.repaint();
        }

        public void paint2(Graphics g){
	    //o 22
	    Font thisFont;
	    thisFont = new Font("Arial", Font.PLAIN, 20);
	    g.setFont(thisFont);
	    //o 21
               String comm = Toolbar.getCommand();
		Commands.add(comm);

         if(comm.equals("Select")){
		selectFunction(g);

         }

         //anshu
         //if Curved line button is selected
         else if ( comm.equals("Curved") ) {

           //if double-click has occurred and at least 2 points have been clicked
           //then new curved line has been created
           if ( numClicks == 2  && Points.size( ) >= 3 ) {

              //create a shape object
              ShapeClass sc = new ShapeClass("Curved");

              Point tempP;

              //add points to the shape's Point vector
              for(int i = 0;  i < Points.size( ) - 1 && i < 4; i++){
                 tempP = (Point) Points.get( i );
                 sc.Points.add(tempP);
              }

              Point p1 = new Point( (Point)sc.Points.get( 0 ) );
              Point p2 = new Point( (Point)sc.Points.get( 1 ) );

              //if 2 points have been specified for the curve
              if ( sc.Points.size( ) == 2 ) {

                 //set the curve
                 sc.quadCurve.setCurve( p1.getX( ), p1.getY( ),
                                        p2.getX( ), p2.getY( ),
                                        p2.getX( ), p2.getY( ) );

                 //set selection box
                 sc.SelectedBox = sc.quadCurve.getBounds( );
              }

              //if 3 points have been specified for the curve
              if ( sc.Points.size( ) == 3 ) {

                 Point p3 = new Point( (Point)sc.Points.get(2) );

                 //set the curve
                 sc.quadCurve.setCurve( p1.getX( ), p1.getY( ),
                                        p2.getX( ), p2.getY( ),
                                        p3.getX( ), p3.getY( ) );

                 //set selection box
                 sc.SelectedBox = sc.quadCurve.getBounds( );
              }

	      //if 4 points have been specified for the curve
              if ( sc.Points.size( ) == 4 ) {

                 Point p3 = new Point( (Point)sc.Points.get(2) );
                 Point p4 = new Point( (Point)sc.Points.get(3) );

                 //set the curve
                 sc.cubeCurve.setCurve( p1.getX( ), p1.getY( ),
                                        p2.getX( ), p2.getY( ),
                                        p3.getX( ), p3.getY( ),
                                        p4.getX( ), p4.getY( ) );

                 //set selection box
                 sc.SelectedBox = sc.cubeCurve.getBounds( );

              }

              //set color of line
              sc.myOutColor = Toolbar.getOutlineColor();

              //deselect all other objects
              setDeselected();

              //set this object as selected
              sc.isSelected = true;

              //create backup of shapes array for undo purposes
              backup();

              //add to shapes vector
              Shapes.add(sc);

              //file has been modified
              clean = false;

              //clear Points array
              Points.clear( );

              //set numClicks
              numClicks = 0;

           }

        } //end If Curved Line

    //******************
    //POLY STUFF omer
    //******************
    else if(Toolbar.getCommand().equals("Poly")){

      //If points have been clicked on the screen
      if( Points.size() >= 1 ){

      //anshu2
      //set color of line to outline color of toolbar
      g.setColor( Toolbar.getOutlineColor( ) );

      //Print first point on the screen
      if ( Points.size( ) == 1 ) {
         Point point1 = new Point( (Point)Points.get( 0 ) );

         g.drawLine( (int)( point1.getX( ) ),
	             (int)( point1.getY( ) ),
	             (int)( point1.getX( ) ),
                     (int)( point1.getY( ) ) );
      }

      //While points are added draw the angular line
      else if ( Points.size( ) >= 2 ) {

         int p1, p2;
         for(p1 = 0, p2 = 1; p2 < Points.size() && numClicks != 2;
             p1++, p2++){

            Point point1 = new Point( (Point)Points.get( p1 ) );
            Point point2 = new Point( (Point)Points.get( p2 ) );

            g.drawLine( (int)( point1.getX( ) ),
			(int)( point1.getY( ) ),
	                (int)( point2.getX( ) ),
                        (int)( point2.getY( ) ) );
         }
      }

      //if double-clicked then add to shapes vector
      if ( numClicks == 2 && Points.size( ) >= 1 ) {

         //copy points to new ShapeClass poly object
         ShapeClass sc = new ShapeClass( "Poly" );

         //backup before changing Shapes array
         backup( );

         for ( int i = 0; i < Points.size( ); i++ ) {
            Point tempPt = (Point)Points.get( i );
            sc.Points.add( tempPt );
            sc.checkFreehandPoints( tempPt);
         }

         //set Selected Box
         int wd = sc.maxwidth - sc.minwidth;
         int ht = sc.maxheight - sc.minheight;
         sc.SelectedBox = new Rectangle(sc.minwidth, sc.minheight,wd, ht);

         //set color
         sc.myOutColor = Toolbar.getOutlineColor();

         //make this object the selected one
         setDeselected();
         sc.isSelected = true;


         //add to Shapes array
         Shapes.add( sc );

         //file has been modified
         clean = false;

         //clear points for next use of poly
         Points.clear( );
         numClicks = 0;

      }

      //}

      }// ends if points.size() >= 1

   }//ends if command == "poly"





	 //*******************************
	 // TEXT STUFF omer
	 //*******************************

    else if(Toolbar.getCommand().equals("Text") && Points.size() == 1){

      //	System.out.println("text test2");
      draggedPts.clear();
      Point p = (Point)Points.elementAt(0);
      Points.clear();

      try{
	String input=JOptionPane.showInputDialog(this,"Enter a string:");
	// System.out.println("cancel");

	if(input.length()>=1){
	  //System.out.println(input.length());
	  ShapeClass sc = new ShapeClass("Text");
	  Point p2 = new Point(0,0);
	  sc.startPoint = p;
	  sc.Points.add(p2);
	  sc.Points.add(p2);

	  //o 21
	  //	  Font thisFont;
	  //thisFont = new Font("Arial", Font.PLAIN, 20);
	  //g.setFont(thisFont);
	  //o 21

	  FontMetrics fm2 = g.getFontMetrics();
	  sc.SelectedBox.setLocation((int)p.getX()-2,(int)p.getY()-fm2.getHeight());

	  if(input.length()<5){
	    sc.SelectedBox.setSize(fm2.stringWidth(input)+25,25);
	  }else{
	    sc.SelectedBox.setSize(fm2.stringWidth(input)+8,25);
	  }
	  sc.text = input;



	  setDeselected();  // deselects all
	  sc.isSelected = true;  // sets tru

	  sc.myOutColor = Toolbar.getOutlineColor( );

	  backup();
	  Shapes.add(sc);
	  draggedPts.clear();

	    //System.out.println(sc.text);
	}
      }
      catch(NullPointerException e){
	//System.out.println("User cancelled input!");
      }
    }




        /*****Dragging ********/

        else if(draggedPts.size()>2){

/**********FREEHAND*************************************/
                if(comm.equals("Freehand")){

           if(stopPoint.x==-1){

	      //anshu2
              //set current color of Toolbar
              g.setColor( Toolbar.getOutlineColor( ) );

                        for(int l=0; l+1<draggedPts.size(); l++){
                                Point p = (Point) draggedPts.get(l);
                                Point p2 = (Point) draggedPts.get(l+1);
                                g.drawLine((int)p.getX(), (int) p.getY(), (int) p2.getX(), (int) p2.getY());

                        }
            }


           else{
            g.setColor(Color.black);
                       ShapeClass sc = new ShapeClass("Freehand");
			Point p1;
                for(int l=0; l<draggedPts.size(); l++){
	          p1 = (Point) draggedPts.get(l);
               sc.Points.add(p1);
		sc.checkFreehandPoints(p1);
		}

		int wd = sc.maxwidth - sc.minwidth;
		int ht = sc.maxheight - sc.minheight;
		sc.SelectedBox = new Rectangle(sc.minwidth, sc.minheight,wd, ht);
		sc.myOutColor = Toolbar.getOutlineColor();
		setDeselected();
		sc.isSelected = true;
  			     backup();
                       Shapes.add(sc);
			clean = false;
                       draggedPts.clear();


            }



                }

/**********FREEHAND DONE*************************************/


/**********RECTANGLE*************************************/

      else if(comm.equals("Rectangle")){

            int wid = (int) (endPoint.getX() - startPoint.getX());
            int ht = (int) (endPoint.getY() - startPoint.getY());

           if(stopPoint.x==-1){
            g.setColor(Color.red);
            g.drawRect((int) startPoint.getX(), (int) startPoint.getY(), wid, ht);
          }

           else{
if(ht>0 && wid >0){
            g.setColor(Color.black);

                       ShapeClass sc = new ShapeClass("Rectangle");
                       sc.Points.add(startPoint);
                       sc.Points.add(stopPoint);
		setDeselected();
		sc.isSelected = true;
		sc.myOutColor = Toolbar.getOutlineColor();
		sc.SelectedBox.setLocation(startPoint);
		sc.SelectedBox.setSize(wid, ht);

	if(!Toolbar.getFillColor().equals(Color.white)){
		        sc.isFilled = true;
			sc.myFillColor = Toolbar.getFillColor();
	}

                       backup();
			clean = false;
                       Shapes.add(sc);
                       draggedPts.clear();
}

           }

     } // ends if Rectangle

/**********RECTANGLE DONE*************************************/


/**********ARROW**********************************************/

/**********LINE*************************************/

      else if(comm.equals("Line") || comm.equals("Arrow")){

           //FIND OUT WIDTH AND HEIGHT OF SELECTION BOX
           int wid = (int) ( endPoint.getX( ) - startPoint.getX( ) );
           int ht = (int) ( endPoint.getY( ) - startPoint.getY( ) );

           if( stopPoint.x == -1 ){
               g.setColor( Color.red );
               g.drawLine((int) startPoint.getX(), (int) startPoint.getY(),(int) endPoint.getX(), (int) endPoint.getY());
           }

           else{

              g.setColor(Color.black);
              ShapeClass sc = new ShapeClass( "Line" );

              if( comm.equals( "Line" ) )
                 sc = new ShapeClass("Line");
              else
                 sc = new ShapeClass("Arrow");

	      Point p1 = startPoint;
	      Point p2 = stopPoint;

              sc.Points.add(p1);
              sc.Points.add(p2);

	      sc.SelectedBox.setLocation( startPoint );
	      sc.SelectedBox.setSize( wid, ht );

              int t = 0;
              t = getTypeLine(p1, p2);

//DEBUG
System.out.println( "Type of Line: " + t );

              int w2 = wid;
	      int h2 = ht;

	      boxLines(t, w2, h2, sc);

	      setDeselected();
	      
              sc.isSelected = true;

	      sc.myOutColor = Toolbar.getOutlineColor();

	      backup();
	      
              clean = false;

              Shapes.add(sc);

              draggedPts.clear();

           }

     } // ends if LINE

/**********LINE DONE*************************************/




/**********ELLIPSE*************************************/

       else if(Toolbar.getCommand().equals("Ellipse")){
       //System.out.println("fill color: " + Toolbar.getFillColor());


            int wid = (int) (endPoint.getX() - startPoint.getX());
            int ht = (int) (endPoint.getY() - startPoint.getY());

           if(stopPoint.x==-1){
            g.setColor(Color.red);
            g.drawOval((int) startPoint.getX(), (int) startPoint.getY(), wid, ht);
          }

           else{
            g.setColor(Color.black);
if(wid>0 && ht>0){
        //    g.drawOval((int) startPoint.getX(), (int) startPoint.getY(), wid, ht);
                       ShapeClass sc = new ShapeClass("Ellipse");
           		sc.startPoint = startPoint;
                       sc.Points.add(startPoint);
                       sc.Points.add(endPoint);
			sc.SelectedBox.setLocation(startPoint);
			sc.SelectedBox.setSize(wid, ht);
			setDeselected();  // deselects all
			sc.isSelected = true;  // sets tru
		sc.myOutColor = Toolbar.getOutlineColor();
	if(!Toolbar.getFillColor().equals(Color.white)){
		        sc.isFilled = true;
			sc.myFillColor = Toolbar.getFillColor();
	}

			     backup();
				clean = false;
                       Shapes.add(sc);


                       draggedPts.clear();
}

           }







       } //ends if Ellipse

/**********ELLIPSE*************************************/



          g.setColor(Color.black);  // DONE DRAGGING, SO SET TO BLACK

        } //ends if drag



                 printShapes(g);

        }


  //Construct the frame
  public DrawingArea(ObjectOrientedDrawer OOD)
  {
    owner = OOD;
    setDefaultCloseOperation(JFrame.DO_NOTHING_ON_CLOSE);
    OODFilter my_filter = new OODFilter();
    fileDialogBox.addChoosableFileFilter(my_filter);
    fileDialogBox.setFileFilter(my_filter);
    addMouseMotionListener(this);
    addMouseListener(this);
    addWindowListener(new WindowAdapter(){
	public void windowClosing(WindowEvent e){
	    //System.err.println("TESTING");
	    fileExit_actionPerformed();
	}
	});

    enableEvents(AWTEvent.WINDOW_EVENT_MASK);
    try
    {
      jbInit();
    }
    catch(Exception e)
    {
      e.printStackTrace();
    }
  }
  //Component initialization
  private void jbInit() throws Exception
  {
    //setIconImage(Toolkit.getDefaultToolkit().createImage(DrawingArea.class.getResource("[Your Icon]")));
    contentPane = (JPanel) this.getContentPane();
    contentPane.setLayout(borderLayout1);
    this.setSize(new Dimension(490, 340));
    this.setTitle("Object Oriented Drawer");
    fileMenu.setText("File");
    editMenu.setText("Edit");
    //helpMenu.setText("Help");
    fileNew.setText("New");
    fileNew.addActionListener(new java.awt.event.ActionListener()
    {
      public void actionPerformed(ActionEvent e)
      {
        fileNew_actionPerformed(e);
      }
    });

    //21 omer
    fileNew.setMnemonic(KeyEvent.VK_N);
    fileNew.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_N,1));
    //21 omer

    fileOpen.setText("Open File...");
    fileOpen.addActionListener(new java.awt.event.ActionListener()
    {
      public void actionPerformed(ActionEvent e)
      {
        fileOpen_actionPerformed(e);
      }
     });

    //21 omer
    fileOpen.setMnemonic(KeyEvent.VK_O);
    fileOpen.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_O,1));
    //21 omer

    fileSave.setText("Save File");
    fileSave.addActionListener(new java.awt.event.ActionListener()
    {
      public void actionPerformed(ActionEvent e)
      {
        fileSave_actionPerformed(e);
      }
    });


    //21 omer
    fileSave.setMnemonic(KeyEvent.VK_S);
    fileSave.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_S,1));
    //21 omer

    fileSaveAs.setText("Save File as...");
    fileSaveAs.addActionListener(new java.awt.event.ActionListener()
    {
      public void actionPerformed(ActionEvent e)
      {
        fileSaveAs_actionPerformed(e);
      }
    });

    fileClose.setText("Close File");
    fileClose.addActionListener(new java.awt.event.ActionListener()
	{
	    public void actionPerformed(ActionEvent e)
	    {
		fileClose_actionPerformed(e);
	    }
	});

    //21 omer
    fileClose.setMnemonic(KeyEvent.VK_C);
    fileClose.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_C,1));
    //21 omer

    fileExit.addActionListener(new java.awt.event.ActionListener()
    {
      public void actionPerformed(ActionEvent e)
      {
        fileExit_actionPerformed();
      }
    });
    fileExit.setText("Exit");
    fileExit.setMnemonic(KeyEvent.VK_E);
    fileExit.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_E,1));

    editUndo.setText("Undo");
    editUndo.addActionListener(new java.awt.event.ActionListener(){
    public void actionPerformed(ActionEvent e){
       editUndo_actionPerformed(e);
    }
    });
    editUndo.setMnemonic(KeyEvent.VK_Z);
    editUndo.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_Z,2));

    selectAll.setText("Select All");
    selectAll.addActionListener(new java.awt.event.ActionListener(){
    public void actionPerformed(ActionEvent e){
       selectAll_actionPerformed(e);
    }
    });
    selectAll.setMnemonic(KeyEvent.VK_A);
    selectAll.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_A,2));

    unselectAll.setText("Unselect All");
    unselectAll.addActionListener(new java.awt.event.ActionListener(){
    public void actionPerformed(ActionEvent e){
       unselectAll_actionPerformed(e);
    }			
    });
    unselectAll.setMnemonic(KeyEvent.VK_U);
    unselectAll.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_U,2));

    editCut.setText("Cut");

    editCut.addActionListener(new java.awt.event.ActionListener(){
    public void actionPerformed(ActionEvent e){
       editCut_actionPerformed(e);
    }
    });

   editCut.setMnemonic(KeyEvent.VK_X);
   editCut.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_X,2));

    editCopy.setText("Copy");
    editCopy.addActionListener(new java.awt.event.ActionListener(){
    public void actionPerformed(ActionEvent e){
       editCopy_actionPerformed(e);
    }
    });

    editCopy.setMnemonic(KeyEvent.VK_C);
    editCopy.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_C,2));

    editPaste.setText("Paste");
    editPaste.addActionListener(new java.awt.event.ActionListener(){
    public void actionPerformed(ActionEvent e){
       editPaste_actionPerformed(e);
    }
    });


    editPaste.setMnemonic(KeyEvent.VK_V);
    editPaste.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_V,2));

    editDelete.setText("Delete");
    editDelete.addActionListener(new java.awt.event.ActionListener(){
    public void actionPerformed(ActionEvent e){
       editDelete_actionPerformed(e);
    }
    });
    editDelete.setMnemonic(KeyEvent.VK_DELETE);
    editDelete.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_DELETE,0,false));

    editSendToBack.setText("Send to Back");
     editSendToBack.addActionListener(new java.awt.event.ActionListener()
    {
        public void actionPerformed(ActionEvent e)
        {
            editSendToBack_actionPerformed(e);
        }
    });


    editBringToFront.setText("Bring to Front");
  editBringToFront.addActionListener(new java.awt.event.ActionListener()
    {
        public void actionPerformed(ActionEvent e)
        {
            editBringToFront_actionPerformed(e);
        }
    });


    //helpAbout.setText("About");
    jPanel1.setBackground(Color.white);
    this.setDefaultCloseOperation(3);
    this.setJMenuBar(menuBar);
    this.setTitle("Object Oriented Drawing");
    this.getContentPane().setLayout(borderLayout1);
    fileDialogBox.setBackground(Color.white);
    //helpContents.setText("Contents");
    //helpContents.addActionListener(new java.awt.event.ActionListener()
    //{
    //  public void actionPerformed(ActionEvent e)
    //  {
    //    helpContents_actionPerformed(e);
    //  }
    //});
    filePrint.setText("Print");
    filePrint.addActionListener(new java.awt.event.ActionListener()
    {
      public void actionPerformed(ActionEvent e)
      {
        filePrint_actionPerformed(e);
      }
    });
    filePrint.setMnemonic(KeyEvent.VK_P);
    filePrint.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_P,1));

    this.getContentPane().add(jScrollPane1, BorderLayout.CENTER);
    menuBar.add(fileMenu);
    menuBar.add(editMenu);
    //menuBar.add(helpMenu);
    fileMenu.add(fileNew);
    fileMenu.add(fileOpen);
    fileMenu.add(fileSave);
    fileMenu.add(fileSaveAs);
    fileMenu.add(fileClose);
    fileMenu.add(filePrint);
    fileMenu.add(fileExit);
    editMenu.add(editUndo);
    editMenu.add(editCut);
    editMenu.add(editCopy);
    editMenu.add(editPaste);
    editMenu.add(editDelete);
    editMenu.add(editSendToBack);
    editMenu.add(editBringToFront);
    editMenu.add(selectAll);
    editMenu.add(unselectAll);


    //helpMenu.add(helpContents);
    //helpMenu.add(helpAbout);
    jScrollPane1.getViewport().add(jPanel1, null);
  }
  //Overridden so we can exit when window is closed
//  protected void processWindowEvent(WindowEvent e)
//  {
//    super.processWindowEvent(e);
//    if (e.getID() == WindowEvent.WINDOW_CLOSING)
//    {
//      //System.exit(0);
//    }
//  }

    void fileNew_actionPerformed(ActionEvent e )
    {

	boolean shouldClear = true;

        if( clean == false )
            {
                Object[] options = { "Yes", "No", "CANCEL" };
		int result  = JOptionPane.showOptionDialog(null, "Do you want to save before opening a new workspace?", "Confirm New Workspace",
							   JOptionPane.YES_NO_CANCEL_OPTION, JOptionPane.QUESTION_MESSAGE,null, options,options[0]);

                if( result == -1 || result == 2 )
                    {
			shouldClear = false;
                        /* Nothing Needs to be Done, User Canceled. */
		}
               else if( result == 1 )
                    {
                        Shapes.clear();
                        Shapes2.clear();

			repaint( );
                        clean = true;
                    }
                else if( result == 0 )
                    {
                        if( fileSaveAs_actionPerformed(e) )
                            {
                                Shapes.clear();
                                Shapes2.clear();
                            }
                    }
            }
        else
            {
		Shapes.clear();
                Shapes2.clear();

            }

	if(shouldClear)
		fileDialogBox.setSelectedFile(null);

    }


    void fileOpen_actionPerformed(ActionEvent e)
    {
	int result = 0;
	if( clean == false )
	    {
		Object[] options = { "Yes", "No", "CANCEL" };
		result  = JOptionPane.showOptionDialog(null, "Do you want to save before opening a new file?", "Confirm New File",
						       JOptionPane.YES_NO_CANCEL_OPTION, JOptionPane.QUESTION_MESSAGE,null, options,options[0]);
		if( result == 1 )
		    {
			Shapes.clear();
			Shapes2.clear();
			clean = true;
		    }
		else if( result == 0 )
		    {
			if( fileSaveAs_actionPerformed(e) )
			    {
				Shapes.clear();
				Shapes2.clear();
			    }
		    }
	    }
	if( result == 1 || result == 0 )
	    {
		fileDialogBox.setDialogTitle( "Open" );
		int result2 = fileDialogBox.showOpenDialog(this);
		if( result2 != fileDialogBox.CANCEL_OPTION )
		    {
			try
			    {
				String my_file = new String((fileDialogBox.getSelectedFile()).getAbsolutePath());
				if( my_file.endsWith( ".ood" ) )
				    {
					File to_open = new File(my_file);
					readin(to_open);

					backup();

					repaint();
				    }
				else
				    {
					Object[] options = {"OK"};
					JOptionPane.showOptionDialog(null, "This file cannot be opened. Please\n select anObject Oriented Drawer file.",
								     "Unknown File Extension", JOptionPane.YES_OPTION, JOptionPane.ERROR_MESSAGE, null,
								     options, options[0]);
				    }
			    }
			catch(Exception e2)
			    {
				Object[] options = {"OK"};
				JOptionPane.showOptionDialog(null, "There was an error reading the selected file", "IO Error",
							     JOptionPane.YES_OPTION, JOptionPane.ERROR_MESSAGE,null, options,options[0]);
			    }
		    }
	    }
    }

  void fileSave_actionPerformed(ActionEvent e)
  {
      if( clean == false )
            {
              try
                  {
		      String my_file = new String((fileDialogBox.getSelectedFile()).getAbsolutePath());
                      if( my_file != null )
                          {
                              if( !(my_file.endsWith( ".ood" )) )
                                  {
                                      my_file = my_file.concat( ".ood" );
                                      File to_set = new File( my_file );
				      fileDialogBox.setSelectedFile(to_set);
                                  }
                              writeout( my_file );
                              clean = true;
                          }
                      else
                          {
                              fileSaveAs_actionPerformed(e);
                          }
                  }
              catch(NullPointerException n )
                  {
                      fileSaveAs_actionPerformed(e);
                  }
            }
  }

    boolean fileSaveAs_actionPerformed(ActionEvent e)
    {
              	fileDialogBox.setDialogTitle("Save");
		    int result = fileDialogBox.showSaveDialog(this);

                if( result != fileDialogBox.CANCEL_OPTION )
                    {
			String my_file = new String((fileDialogBox.getSelectedFile()).getAbsolutePath());
                        if( my_file != null )
                            {
                                if( !(my_file.endsWith( ".ood" )) )
                                    {
                                        my_file = my_file.concat( new String(".ood") );
                                        File to_set = new File( my_file );
					fileDialogBox.setSelectedFile(to_set);
                                    }
                                writeout( my_file );
				clean = true;
                                return true;
                            }
                        else
                            {
                                Object[] options = { "OK" };
				JOptionPane.showOptionDialog(null, "Error writing to the specified file","SaveError",JOptionPane.DEFAULT_OPTION, JOptionPane.ERROR_MESSAGE,
							     null, options, options[0]);
                                return false;
                            }
                    }
                else
                    {
                        return false;
                    }
   
    }

    void filePrint_actionPerformed(ActionEvent e){
	try
	    {
		BufferedImage toPrint = (new Robot(this.getGraphicsConfiguration().getDevice())).createScreenCapture(new Rectangle(0, 0, this.getWidth(), this.getHeight()));
		PrinterJob printerJob = PrinterJob.getPrinterJob();
		PageFormat pageFormat = printerJob.defaultPage();
		if(printerJob.pageDialog(pageFormat) != pageFormat){
		    if(printerJob.printDialog()){
			printerJob.setPrintable(new PrinterRendering(toPrint));
			printerJob.print();
		    }
		}
	    }
	catch(Exception e2)
	    {
		System.out.println( "Debug: " + e2.toString() );
	    }
    }


    void fileExit_actionPerformed(){
	int result = 0;
	if( clean == false )
	    {
		Object[] options = { "Yes", "No", "CANCEL" };
                result  = JOptionPane.showOptionDialog(null, "Do you want to save before exiting?", "Save on Exit",
						       JOptionPane.YES_NO_CANCEL_OPTION, JOptionPane.QUESTION_MESSAGE,null, options,options[0]);
		if( result == -1 || result == 2 )
		    {
			// user canceled request. do nothing
		    }
		else if( result == 0 )
		    {
			if( fileSaveAs_actionPerformed(null) == false )
			    {
				result = 2;
			    }
		    }
	    }
	if( result == 0 || result == 1 )
	    {
		owner.close();
	    }
    }


    void editPaste_actionPerformed(ActionEvent e)
    {
	Commands.add("Paste");
	Object fromClip =  Toolkit.getDefaultToolkit().getSystemClipboard().getContents(this);

	if( fromClip != null )
	    {
		try{
		    TerpClipboardInterface terp = (TerpClipboardInterface)fromClip;
		    clean = false;
		    backup();
		    for (int i = 0; i < Shapes.size(); i++)
			{
			    ((ShapeClass)Shapes.get(i)).isSelected = false;
			}
		    if( terp.copiedFrom() == terp.OOD)
			{
			    OODClipObj ood = (OODClipObj)terp;
			    ShapeClass temp[] = ood.getCopy();

			    for (int i = 0; i < temp.length; i++)
				{
				    temp[i].isSelected = true;
				    Shapes.add(temp[i]);
				}
			}
		    else if( terp.copiedFrom() == terp.SPREADSHEET )
			{
			    if( terp.getString() != null )
				{
				    ShapeClass sc = new ShapeClass("Text");
                                    sc.text = terp.getString();
                                    sc.Points.add(new Point(35,75));

				    Graphics g = this.getGraphics();
                                    FontMetrics fm2 = g.getFontMetrics();
                                    // g.drawRect((int)startPoint.getX()-2,(int)startPoint.getY()-12, fm2.stringWidth(text)+2,fm2.getHeight());

                                    sc.SelectedBox.setLocation(35,75);

                                    if(sc.text.length()<5){
                                        sc.SelectedBox.setSize(fm2.stringWidth(sc.text)+25,25);
                                    }else{
                                        sc.SelectedBox.setSize(fm2.stringWidth(sc.text)+8,25);
                                    }
                                    sc.isSelected = true;
                                    Shapes.add(sc);
				}
			    else
				{
				  ShapeClass sc = new ShapeClass("Image");
				  sc.Points.add(new Point(35,75));
				  sc.image = terp.getImage();
				  sc.Points.add(new Point(35 + sc.image.getWidth(), 75 + sc.image.getHeight()));
				  sc.SelectedBox = new Rectangle(31,71,sc.image.getWidth()+4, sc.image.getHeight()+4);
				  sc.isSelected = true;
				  Shapes.add(sc);
				}
			}
		    else if (terp.copiedFrom() == terp.CALC || terp.copiedFrom() == terp.INTEGRATOR)
			{
			    if( terp.getString() != null )
				{
				    ShapeClass sc = new ShapeClass("Text");
				    sc.text = terp.getString();
				    sc.Points.add(new Point(35,75));
				    Graphics g = this.getGraphics();
				    FontMetrics fm2 = g.getFontMetrics();
				    // g.drawRect((int)startPoint.getX()-2,(int)startPoint.getY()-12, fm2.stringWidth(text)+2,fm2.getHeight());

				    sc.SelectedBox.setLocation(35,75);

				    if(sc.text.length()<5){
					sc.SelectedBox.setSize(fm2.stringWidth(sc.text)+25,25);
				    }else{
					sc.SelectedBox.setSize(fm2.stringWidth(sc.text)+8,25);
				    }
				    sc.isSelected = true;
				    Shapes.add(sc);
				}
			}
		    else
			{
			  ShapeClass sc = new ShapeClass("Image");
			  sc.Points.add(new Point(35,75));
			  sc.image = terp.getImage();
			  sc.Points.add(new Point(35 + sc.image.getWidth(), 75 + sc.image.getHeight()));
			  sc.SelectedBox = new Rectangle(31,71,sc.image.getWidth()+4, sc.image.getHeight()+4);
			  sc.isSelected = true;
			  Shapes.add(sc);

			}
		}catch(Error e2){}

		repaint();
	    }
    }

    void editCopy_actionPerformed(ActionEvent e)
    {
      Commands.add("Copy");
	copy_and_cut(1);
    }

    void editBringToFront_actionPerformed(ActionEvent e)
    {
	int index = 0;
	if( numSelected() == 1 )
	    {
		backup();
		clean = false;
		boolean exit_loop = false;
		for( index=0; index < Shapes.size() && exit_loop ==false; index++ )
		    {
			if( ((ShapeClass)Shapes.elementAt(index)).isSelected == true)
			    {
				exit_loop = true;
			    }
		    }
		index--;
		ShapeClass to_move = ((ShapeClass)Shapes.remove(index));
		to_move.isSelected = true;
		setDeselected();
		Shapes.add(to_move);
	    }
	else
	    {
		Object[] options = { "OK" };
		JOptionPane.showOptionDialog(null, "You can only bring one object to the front!", "Too Many Objects",
					     JOptionPane.DEFAULT_OPTION, JOptionPane.ERROR_MESSAGE,
					     null, options, options[0]);
	    }
    }

 void editSendToBack_actionPerformed(ActionEvent e)
  {

   int index = 0;
      if( numSelected() == 1 )
          {
              backup();
		clean = false;
              boolean exit_loop = false;

          for( index=0; index < Shapes.size() && exit_loop == false; index++ )
                  {
               if( ((ShapeClass)Shapes.elementAt(index)).isSelected ==true )
                          {
                              exit_loop = true;
                          }
                  }
              index--;
              ShapeClass to_move = ((ShapeClass)Shapes.remove(index));
	      to_move.isSelected = false;
              Shapes.add( 0, to_move );
	      ShapeClass to_selected = ((ShapeClass)Shapes.get(Shapes.size()-1));
	      to_selected.isSelected = true;

          }
      else
          {
              Object[] options = { "OK" };
              JOptionPane.showOptionDialog(null, "You can only send one object to the back!", "Too Many Objects",
                                           JOptionPane.DEFAULT_OPTION, JOptionPane.ERROR_MESSAGE,
                                           null, options, options[0]);
          }


  }


 int numSelected()
  {
    int index = 0;
    int result = 0;
    for( index = 0; index < Shapes.size(); index++ )
        {
            if( ((ShapeClass)Shapes.elementAt(index)).isSelected == true )
            {
              result++;
            }
        }
    return result;
  }




  void editCut_actionPerformed(ActionEvent e)
  {
	Commands.add("Cut");
	copy_and_cut(2);
  }


  void editDelete_actionPerformed(ActionEvent e)
  {
     Vector tempShape = new Vector();
        tempShape = (Vector) Shapes.clone();

        for(int x=0; x<Shapes.size(); x++){
             ShapeClass SC = (ShapeClass) Shapes.get(x);
             if(SC.isSelected){

                if(SC.hasArrow){
		    if(SC.hasArrowHead){
			// this was causing recursive problems.  i dont think we need it at all
    //int index = 0;
    //for( index = 0; index < SC.links.size(); index++ )
    //{
    //ShapeClass temp = ((ShapeClass)SC.links.elementAt(index));
		//if( temp.hasArrowHead == false )
		//     {
		// Only arrow associated with this pointed to shape
		// temp.hasArrow = false;
		//      temp.links.clear();
		//   }
		//  }
		//SC.link.hasArrow = false;
		//SC.link.hasArrowHead = false;
		//SC.link.link = null;
	     }
	     else{
		 for(int l=0; l<Shapes.size(); l++){
		     ShapeClass currentShape = ((ShapeClass)Shapes.elementAt(l));
		     int l2=0;
		     for( l2=0; l2<currentShape.links.size(); l2++ )
			 {
			     if( ((ShapeClass)(currentShape.links.elementAt(l2))) == SC )
				 {
				     currentShape.links.remove(l2);
				 }
			 }
		     if( currentShape.links.size() == 0 )
			 {
			     currentShape.hasArrow = false;
			 }


		     /*Commenting this out of original code. May need to return
                               if(((ShapeClass)Shapes.elementAt(l)).link == SC)
{
//backup();
((ShapeClass)Shapes.elementAt(l)).link =null;
((ShapeClass)Shapes.elementAt(l)).hasArrow = false;

((ShapeClass)Shapes.elementAt(l)).hasArrowHead = false;
 } // end if
                             */
		 } // end for
	     }  // end else

             } // if has arrow

                  tempShape.remove(SC);     // REMOVES SHAPES THAT ARE SELECTED

        } // if isselected

    } // end for

        backup();
        clean = false;
        Shapes = (Vector) tempShape.clone();
	resetArrowsAfterDelete();

	repaint();
 }
  void selectAll_actionPerformed(ActionEvent e)
   {
	for(int x =0; x<Shapes.size(); x++){
		ShapeClass sc = (ShapeClass)Shapes.get(x);
		sc.isSelected = true;
	}

    }

void unselectAll_actionPerformed(ActionEvent e){
    for(int x =0; x<Shapes.size(); x++){
	ShapeClass sc = (ShapeClass)Shapes.get(x);
	sc.isSelected = false;
    }
}


    void editUndo_actionPerformed(ActionEvent e)
    {

	int index = 0;
	Shapes.clear();
	for( index = 0; index < Shapes2.size(); index++ )
	    {
		System.out.println("called undo");
		Shapes.add( Shapes2.elementAt(index) );
	    }
	repopulateArrows();
    }

    void repopulateArrows(){
        for (int index = 0; index < Shapes.size(); index++ ){
            ShapeClass SC = (ShapeClass)Shapes.elementAt(index);
            if (SC.hasArrowHead){
                for (int i = 0; i < SC.links.size(); i++){                  
		    try{
                        int curr = ((Integer)SC.links.elementAt(i)).intValue();
                        ShapeClass arr = (ShapeClass)Shapes.elementAt(curr);
                        arr.hasArrow = true;
                        SC.links.set(i,arr);
                    }catch (Error e1){}
                    catch(Exception e2){}
                }
            }
        }
    }

    void resetArrowsAfterDelete(){
	for(int index = 0; index < Shapes.size(); index++){
	    ShapeClass SC = (ShapeClass)Shapes.elementAt(index);
	    if (SC.hasArrowHead){
		for (int i = 0; i < SC.links.size(); i++){
		    ShapeClass s = (ShapeClass)SC.links.elementAt(i);
		    if (getShapeIndex(s) < 0){
			SC.links.remove(i);
			i--;
		    }
		}
	    }
	}
    }

    void backup()
    {
        int index = 0;
        Shapes2.clear();
        for( index = 0; index < Shapes.size(); index++ )
            {
                ShapeClass S = (ShapeClass) Shapes.elementAt(index);
		ShapeClass SC = new ShapeClass(S.type);
                SC.type = new String(S.type);
                SC.Points = new Vector(S.Points);
                SC.startPoint = new Point(S.startPoint);
                SC.SelectedBox = new Rectangle(S.SelectedBox);
                SC.isSelected = S.isSelected;
                SC.myOutColor = S.myOutColor;
                SC.myFillColor = S.myFillColor;
                SC.isFilled = S.isFilled;
                //o 21 text
                SC.text = S.text;
                // 21 text
                SC.hasArrowHead = false;
                if (S.hasArrowHead){
                    Vector temp = new Vector();
                    for (int i = 0; i < S.links.size(); i++){
                        int curr = getShapeIndex((ShapeClass)S.links.elementAt(i));
			if (curr >= 0)  temp.add(new Integer(curr));
		    }
			if (temp.size() > 0){
			    System.err.println("HASARROW WORK");
			    SC.hasArrowHead = true;
			    SC.links = temp;
			}
		    }

		    Shapes2.add( SC );
		}
	    }

	private int getShapeIndex (ShapeClass s){
	    for (int i = 0; i < Shapes.size(); i++){
		ShapeClass t = (ShapeClass)Shapes.elementAt(i);
		if (s == t) return i;
	    }
	    return -1;
	}

    void copy_and_cut( int foo )
    {
	// i == 1  From Copy
	// i == 2 From Cut
	if (numSelected() > 0)
	    {
		int max = Shapes.size();
		backup();
		for( int index = 0; index < max; index++ )
		    {
			if (((ShapeClass)Shapes.elementAt(index)).isSelected == false)
			    {
				Shapes.remove(index);
				index--;
				max--;
			    }
		    }
		// Temporarily setting isSelected to false
		for( int index = 0; index < Shapes.size(); index++ )
		    {
			((ShapeClass)Shapes.elementAt(index)).isSelected = false;
		    }

		double upperX = 10000.0, upperY = 10000.0, lowerX = 0, lowerY = 0;
		//use these to get largest bounding area for buffered image

		for (int j = 0; j < Shapes.size(); j++)
		    {
			Rectangle r = ((ShapeClass)Shapes.get(j)).SelectedBox;
			if (r.getX() < upperX) upperX = r.getX();
			if (r.getY() < upperY) upperY = r.getY();
			if ((r.getX() + r.getWidth()) > lowerX) lowerX = (r.getX() + r.getWidth());
			if ((r.getY() + r.getHeight()) > lowerY) lowerY = (r.getY() + r.getHeight());
		    }//now the bounding box exists in the X, Y coords above
		try
		    {
			Robot robot = new Robot(this.getGraphicsConfiguration().getDevice());
			OODClipObj toPaste;

			paint(this.getGraphics());
			// 120 accounts for toolbar, then adjust by 1 to get a uniform border
			Rectangle my_rect = new Rectangle(((int)upperX + 119), (int)upperY - 1, (int)((lowerX - upperX) + 1), (int)((lowerY - upperY) + 1));
			BufferedImage img = robot.createScreenCapture(my_rect);
			String pasteString = null;
			if (Shapes.size()==1 && ((ShapeClass)Shapes.elementAt(0)).type.equals("Text"))
			    {
				//need to account for case of just pasting a string object
				pasteString = new String (((ShapeClass)Shapes.elementAt(0)).text);
				toPaste = new OODClipObj(null, Shapes.toArray(), pasteString);
			    }
			else
			    {
				toPaste = new OODClipObj(img, Shapes.toArray(), pasteString);
			    }

			editUndo_actionPerformed(null);
			clean = false;
			backup();
			if( foo == 2 )
			    {
				//if cut need to now remove all those things that are selected
				editDelete_actionPerformed(null);
			    }

			repaint();

			//now add code to actually put it to the clipboard ARGH
			Toolkit.getDefaultToolkit().getSystemClipboard().setContents(toPaste, this);
		    }
		catch(Exception e)
		    {
		    }
	    }
    }

    public void lostOwnership(Clipboard clipboard, Transferable contents){}


  void fileClose_actionPerformed(ActionEvent e)
  {
      fileNew_actionPerformed(e);
  }

  //void helpContents_actionPerformed(ActionEvent e)
  //{
  //new HelpWindow();
  //}

    void writeout( String my_file )
    {
        try
            {
		int num_images = 0;
                int index = 0, pindex = 0;
                FileOutputStream fout =  new FileOutputStream(my_file);
                PrintStream my_out = new PrintStream(fout);
		//need this
		converter newConv = new converter();

                for( index = 0; index < Shapes.size(); index++ )
                    {
                        ShapeClass to_print = ((ShapeClass)Shapes.elementAt(index));
                        my_out.print( to_print.type + " " );
			if( to_print.type.equals( "Image" ) )
			    {
				num_images++;
				String temp = new String(my_file);
				temp = temp.concat( "-pic" );
				temp = temp.concat( String.valueOf(num_images) );
				//System.out.println( "Debug: here's the picture file name: " + temp + "\n" );
				FileOutputStream fos = new FileOutputStream(temp);
				newConv.BufferedImageToFile(fos, to_print.image, 0);
				fos.close();
			    }
			my_out.print( to_print.text + " " );
			my_out.print( to_print.startPoint.getX() + " " + to_print.startPoint.getY() + " ");
			if( to_print.myOutColor == null )
			    {
                                //my_out.print( "null " );
                              my_out.print( "0 0 0 ");
	    }
			else
			    {
//  my_out.print(myOutColor);
                                my_out.print( to_print.myOutColor.getRed() + " ");
                                my_out.print( to_print.myOutColor.getGreen() + " ");
                                my_out.print( to_print.myOutColor.getBlue() + " ");
			    }
			if( to_print.myFillColor == null )
			    {
			my_out.print( "null " );
		//		my_out.print( "0 0 0 ");
	    }
			else
			    {
                                my_out.print( to_print.myFillColor.getRed() + " ");
                                my_out.print( to_print.myFillColor.getGreen() + " ");
                                my_out.print( to_print.myFillColor.getBlue() + " ");

                            //    my_out.print( to_print.myFillColor.getRGB() + " " );
			    }
                        if( to_print.isFilled == true )
                            {
                                my_out.print( "true " );
                            }
                        else
                            {
                                my_out.print( "false " );
                            }
                        my_out.print( (int)((Rectangle)to_print.SelectedBox).getX() + " " );
                        my_out.print( (int)((Rectangle)to_print.SelectedBox).getY() + " " );
                        my_out.print( (int)((Rectangle)to_print.SelectedBox).getWidth() + " " );
                        my_out.print( (int)((Rectangle)to_print.SelectedBox).getHeight() + " " );

                        my_out.print( (int)((Rectangle)to_print.bottomPoint).getX() + " " );
                        my_out.print( (int)((Rectangle)to_print.bottomPoint).getY() + " " );
                        my_out.print( (int)((Rectangle)to_print.bottomPoint).getWidth() + " " );
                        my_out.print( (int)((Rectangle)to_print.bottomPoint).getHeight() + " " );

                        my_out.print( (int)((Rectangle)to_print.topPoint).getX() + " " );
                        my_out.print( (int)((Rectangle)to_print.topPoint).getY() + " " );
                        my_out.print( (int)((Rectangle)to_print.topPoint).getWidth() + " " );
                        my_out.print( (int)((Rectangle)to_print.topPoint).getHeight() + " " );

                        my_out.print( (int)((Rectangle)to_print.rightPoint).getX() + " " );
                        my_out.print( (int)((Rectangle)to_print.rightPoint).getY() + " " );
                        my_out.print( (int)((Rectangle)to_print.rightPoint).getWidth() + " " );
                        my_out.print( (int)((Rectangle)to_print.rightPoint).getHeight() + " " );

                        my_out.print( (int)((Rectangle)to_print.leftPoint).getX() + " " );
                        my_out.print( (int)((Rectangle)to_print.leftPoint).getY() + " " );
                        my_out.print( (int)((Rectangle)to_print.leftPoint).getWidth() + " " );
                        my_out.print( (int)((Rectangle)to_print.leftPoint).getHeight() + " " );

                        if( to_print.isSelected == true )
                            {
                                my_out.print( "true " );
                            }
                        else
                            {
                                my_out.print( "false " );
                            }
			if( to_print.hasArrow == true )
			    {
				my_out.print( "true " );
				if( to_print.hasArrowHead == true )
				    {
					my_out.print( "true " );
					my_out.print( to_print.links.size() + " ");
					for (int jj = 0; jj < to_print.links.size(); jj++){
					    ShapeClass temp = (ShapeClass)to_print.links.elementAt(jj);
					    int curr = getShapeIndex(temp);
					    my_out.print(curr + " ");
					}
				    }
				else
				    {
					my_out.print( "false " );
				    }
			    }
			else
			    {
				my_out.print( "false " );
			    }
                        if( to_print.type.equals( "Arrow" ) )
                            {
                                my_out.print( (int)((Point)to_print.arrowHead).getX() + " " +
                                              (int)((Point)to_print.arrowHead).getY() + " " );
                            }
			my_out.print( (int)to_print.maxheight + " " );
			my_out.print( (int)to_print.minheight + " " );
			my_out.print( (int)to_print.maxwidth + " " );
			my_out.print( (int)to_print.minwidth + " " );
                        for( pindex = 0; pindex < to_print.Points.size(); pindex++ )
                            {
                                my_out.print( (int)((Point)to_print.Points.elementAt(pindex)).getX() + " " +
                                              (int)((Point)to_print.Points.elementAt(pindex)).getY() + " " );
                            }

      			my_out.print( "done " );
			if( to_print.type.equals( "Image" ) )
			    {
				// do something to save bufferedimages as .jpegs
			    }
                        my_out.print( "\n" );

                        my_out.flush();
                    }

                my_out.flush();
                my_out.close();
                fout.close();
            }
        catch(IOException e)
            {
                System.out.println("Error opening file: " + e);
                System.exit(1);
            }
    }

  void readin(File my_file) {
      Vector indices = new Vector();
      String my_string = new String((fileDialogBox.getSelectedFile()).getAbsolutePath());
      if( my_file != null )
	  {
                    try
                        {
                            BufferedReader in = new BufferedReader(new FileReader(my_string));
			    int num_images = 0;
			    // need this
			    converter newConv = new converter();


                            /* Start Parsing code here */
			    System.out.println("Begins shape: " + Shapes.size());
                            String input = new String();
                            while( (input = in.readLine()) != null )
                                {
				    int x = 0;
				    int y = 0;
				    int width = 0;
				    int height = 0;
                                    StringTokenizer tokens = new StringTokenizer( input );
                                    String token = new String();
                                    token = tokens.nextToken();  // reads type of shape
                                    ShapeClass sc = new ShapeClass( token );
				    if( token.equals( "Image" ) )
					{
					    // Taking Care of images
					    num_images++;
					    String temp = new String(my_string);
					    temp = temp.concat( "-pic" );
					    temp = temp.concat( String.valueOf(num_images) );
					    FileInputStream fis = new FileInputStream(temp);
					    sc.image = newConv.FileToBufferedImage(fis);
					    fis.close();
					}
				    Double d1;
				    Double d2;

                                    token = tokens.nextToken(); // reads text
                                    sc.text = token;
				    token = tokens.nextToken();
				    d1 = new Double(token);
				    token = tokens.nextToken();
				    d2 = new Double(token);
                                    sc.startPoint.setLocation(d1.doubleValue(),d2.doubleValue());
				    token = tokens.nextToken();  // reads numbers for outcolor, or null
				    if( token.equals("null") )
					{

//						sc.myOutColor = null;
                                                sc.myOutColor = Color.black;
					}
				    else
					{
                                                String s = token;

                                                token = tokens.nextToken(); //gets r
                                                String s2 = token;
                                                token = tokens.nextToken(); //gets bl
                                                String s3 = token;
                                              //  token = tokens.nextToken(); //gets gree

                                                sc.myOutColor = new Color(new Integer(s).intValue(), new Integer(s2).intValue(), new Integer(s3).intValue());
                                              //  sc.myOutColor = Color.black;
					}
				    token = tokens.nextToken();
				    if( token.equals("null") )
					{
                                            sc.myFillColor = Color.white;

                                	}
				    else
					{
                                                String s4 = token;

                                                token = tokens.nextToken(); //gets r
                                                String s5 = token;
                                                token = tokens.nextToken(); //gets bl
                                                String s6 = token;


                                                sc.myFillColor = new Color(new Integer(s4).intValue(), new Integer(s5).intValue(), new Integer(s6).intValue());

                                            //new Color((new Integer(token)).intValue());
					}
				    token = tokens.nextToken();
				    if( token.equals("true") )
					{
					    sc.isFilled = true;
					}
				    else
					{
					    sc.isFilled = false;
					}
				    token = tokens.nextToken();
				    x = ((new Integer(token)).intValue());
				    token = tokens.nextToken();
				    y = (new Integer(token)).intValue();
				    sc.SelectedBox.setLocation(x,y);
				    token = tokens.nextToken();
				    width = (new Integer(token)).intValue();
				    token = tokens.nextToken();
				    height = (new Integer(token)).intValue();
				    sc.SelectedBox.setSize(width,height);

				    token = tokens.nextToken();
				    x = (new Integer(token)).intValue();
				    token = tokens.nextToken();
				    y = (new Integer(token)).intValue();
				    sc.bottomPoint.setLocation(x,y);
				    token = tokens.nextToken();
				    width = (new Integer(token)).intValue();
				    token = tokens.nextToken();
				    height = (new Integer(token)).intValue();
				    sc.bottomPoint.setSize(width,height);

				    token = tokens.nextToken();
				    x = (new Integer(token)).intValue();
				    token = tokens.nextToken();
				    y = (new Integer(token)).intValue();
				    sc.topPoint.setLocation(x,y);
				    token = tokens.nextToken();
				    width = (new Integer(token)).intValue();
				    token = tokens.nextToken();
				    height = (new Integer(token)).intValue();
				    sc.topPoint.setSize(width,height);

				    token = tokens.nextToken();
				    x = (new Integer(token)).intValue();
				    token = tokens.nextToken();
				    y = (new Integer(token)).intValue();
				    sc.rightPoint.setLocation(x,y);
				    token = tokens.nextToken();
				    width = (new Integer(token)).intValue();
				    token = tokens.nextToken();
				    height = (new Integer(token)).intValue();
				    sc.rightPoint.setSize(width,height);

				    token = tokens.nextToken();
				    x = (new Integer(token)).intValue();
				    token = tokens.nextToken();
				    y = (new Integer(token)).intValue();
				    sc.leftPoint.setLocation(x,y);
				    token = tokens.nextToken();
				    width = (new Integer(token)).intValue();
				    token = tokens.nextToken();
				    height = (new Integer(token)).intValue();
				    sc.leftPoint.setSize(width,height);

				    token = tokens.nextToken();
				    if( token.equals("true") )
					{
					    sc.isSelected = true;
					}
				    else
					{
					    sc.isSelected = false;
					}
				    token = tokens.nextToken();
				    if( token.equals("true") )
					{
					    sc.hasArrow = true;
					    token = tokens.nextToken();
					    if( token.equals("true") )
						{
						    sc.hasArrowHead = true;
						    token = tokens.nextToken();
						    x = (new Integer(token)).intValue();
	     					    for (int ii = 0; ii < x; ii++){
							token=tokens.nextToken();
							Integer link = new Integer(token);
							sc.links.add(link);
						    }
					
						}
					    else
						{
						    sc.hasArrowHead = false;
						}


					}
				    else
					{
					    sc.hasArrow = false;
					    sc.links.clear();
					}

				    if( sc.type.equals("Arrow") )
					{
					    token = tokens.nextToken();
					    x = (new Integer(token)).intValue();
					    token = tokens.nextToken();
					    y = (new Integer(token)).intValue();
					    sc.arrowHead.setLocation(x,y);
					}
                                    //get points
                                        sc.Points.clear(); //new
                                        token = tokens.nextToken(); //gets 0
                                        token = tokens.nextToken(); //gets 1000000
                                        token = tokens.nextToken(); //gets 0
                                        token = tokens.nextToken(); //gets 1000000

					while( tokens.hasMoreTokens() )
                                        {
                                            token = tokens.nextToken();

                                            if( !(token.equals( "done" )) )
                                                {

                                                    Point to_add = new Point();
						    x = (new Integer(token)).intValue();
                                                    token = tokens.nextToken();
						    y = (new Integer(token)).intValue();
                                                    to_add.setLocation(x,y);
                                                    sc.Points.add(to_add);

                                         }
					   else
						break;
                                        }

				    //get image
                                    Shapes.add( sc );
                                }
			    
			    repopulateArrows();

			    repaint();
                        }
                    catch(IOException i)
                        {
			    System.out.println( "Debug: one" );
			    Object[] options = {"OK"};
			    JOptionPane.showOptionDialog(null, "File cannot be opened.", "IO Error", JOptionPane.YES_OPTION, JOptionPane.ERROR_MESSAGE, null,
							 options, options[0]);
                        }
	  }
      else
	  {
	      System.out.println( "Debug: two" );
	      Object[] options = {"OK"};
	      JOptionPane.showOptionDialog(null, "File cannot be opened.", "IO Error", JOptionPane.YES_OPTION, JOptionPane.ERROR_MESSAGE, null,
					   options, options[0]);
	  }
  }


    public class SimplePainter{
	private BufferedImage image;
	private int Margin = 10;
	private Dimension size;
	private Paint gradientPaint;

	public SimplePainter(BufferedImage i){
	    if (i != null){
		image = i;
		int w = image.getWidth();
		int h = image.getHeight();
		size = new Dimension(w, h);

		Color darkBlue = new Color (63, 64, 124);
		Color lightBlue = new Color (112, 128, 154);
		gradientPaint = new GradientPaint(0,0,darkBlue,0,h,lightBlue);
	    }
	}

	public Dimension getSize(){
	    return size;
	}

	public void render(Graphics2D g){
	    g.setPaint(gradientPaint);
	    g.fillRect(0,0,size.width,size.height);
	    g.drawImage(image, Margin,Margin, null);
	}
    }
    public class PrinterRendering implements Printable{
	private SimplePainter painter;
	public PrinterRendering(BufferedImage i){
	    painter = new SimplePainter(i);
	}
	public int print(Graphics _g, PageFormat pageFormat, int pageIndex){
	    if (pageIndex == 0){
		Graphics2D g = (Graphics2D)_g;
		double xMargin = (pageFormat.getImageableWidth() - painter.getSize().width)/2;
		double yMargin = (pageFormat.getImageableHeight() - painter.getSize().height)/2;
		g.translate(pageFormat.getImageableX() + xMargin, pageFormat.getImageableY() + yMargin);
		painter.render(g);
		return PAGE_EXISTS;
	    }
	    else return NO_SUCH_PAGE;
	}
	/*public static void main(String args[]) throws Exception{
	  PrinterJob printerJob = PrinterJob.getPrinterJob();
	  PageFormat pageFormat = printerJob.getDefaultPage();
	  if(printerJob.pageDialog(pageFormat) != pageFormat){
	  if(printerJob.printDialog()){
	  printerJob.setPrintable(new PrinterRendering(args[0]);
	  //replace args[0] with the bufferedimage file to be printed
	  printerJob.print();
	  }
	  }
	  }*/
    }
    public class OODClipObj implements Transferable, TerpClipboardInterface{
	public String str;
	public BufferedImage img;
	public ShapeClass shapes[];
	int max = 0;

        public DataFlavor imageFlavor;
        public DataFlavor stringFlavor;
        private DataFlavor [] supportedFlavors = {imageFlavor, stringFlavor};

	public OODClipObj(BufferedImage i, Object s[], String st){
	    img = i;
	    max = s.length;
	    shapes = new ShapeClass[s.length];
	    for (int i2 = 0; i2 < shapes.length; i2++){
		try
		    {
			shapes[i2] = new ShapeClass((ShapeClass)s[i2]);
		    }catch (Error e){ max--; }
	    }
	    if( st != null )
		{
		    str = new String(st);
		}
	    else
		{
		    str = null;
		}

            try {
                imageFlavor = new DataFlavor (Class.forName("java.awt.Image.BufferedImage"), "Buffered Image");
                stringFlavor = new DataFlavor (Class.forName("java.lang.String"), "String");
            }
            catch (ClassNotFoundException e) {}
	}

	public BufferedImage getImage(){ return img; }

	public String getString(){ return str; }

        public String toString(){ return str; }

	public int copiedFrom(){ return 3; }

	public ShapeClass[] getCopy(){
	    ShapeClass toReturn[] = new ShapeClass[max];
	    for (int i = 0; i < toReturn.length; i++){
		toReturn[i] = new ShapeClass((ShapeClass)shapes[i]);
	    }
	    return toReturn;
	}

	public Object getTransferData(DataFlavor flavor) {
	    //if (flavor.equals(imageFlavor)) return getImage();
	   //           return getString();
	    return null;
	}
	public DataFlavor[] getTransferDataFlavors() { //return supportedFlavors; 
	    return null;
	}
	public boolean isDataFlavorSupported(DataFlavor flavor) {return false;}
    }
}
