import java.awt.event.*;
import javax.swing.*;
import java.io.*;
import java.util.*;
import javax.swing.UIManager;
import java.awt.*;
import java.awt.*;
import java.awt.event.*;
import java.awt.print.*;
import java.awt.image.*;
import java.awt.geom.*;
import javax.swing.*;
import java.io.*;
import java.util.*;
import java.awt.datatransfer.*;


public class ObjectOrientedDrawer extends JFrame implements TerpOfficeAppInterface
{
    boolean packFrame = false;
    protected Toolbar toolbar = new Toolbar();
    public DrawingArea frame = new DrawingArea(this);

    //Construct the application
    public ObjectOrientedDrawer(){}
    //does nothing, just creates object, won't 'exist' before launch

    public boolean alive(){
	return frame.isDisplayable();
    }

    public void paintAgain(){
	frame.repaint();
    }

    public void close(){
	frame.dispose();
	if (!frame.isDisplayable()) toolbar.dispose();
    }
  
    public void launch(File file)
    //public void launch()
    {
	//Validate frames that have preset sizes
	//Pack frames that have useful preferred size info, e.g. from their layout
	if (packFrame)
	    {
		frame.pack();
	    }
        else
	{
	    frame.validate();
	}

	//Center the window
	Dimension screenSize=Toolkit.getDefaultToolkit().getScreenSize();
	Dimension frameSize = frame.getSize();
	if (frameSize.height > screenSize.height)
	    {
		frameSize.height = screenSize.height;
	    }

	if (frameSize.width > screenSize.width)
	    {
		frameSize.width = screenSize.width;
	    }
	//    int frameX = (screenSize.width - frameSize.width) / 2;
	//    int frameY = (screenSize.height - frameSize.height) / 2;
	int frameX = (screenSize.width - frameSize.width);
	int frameY = (screenSize.height - frameSize.height);

	toolbar.setLocation(0,0);
	frame.setSize(850,650);
	frame.setDefaultCloseOperation(JFrame.DO_NOTHING_ON_CLOSE);
	frame.setResizable(false);
	frame.setLocation(120,0);
	frame.setVisible(true);
	toolbar.setVisible(true);
	toolbar.setDefaultCloseOperation(JFrame.DO_NOTHING_ON_CLOSE);


	if (file != null){
	    frame.readin(file);
	}


    }



}
