//TerpClipboardInterface.java

import java.awt.image.BufferedImage;

public interface TerpClipboardInterface {
  //these are contants that will be used to identify the source of the Object
    static int SPREADSHEET = 1;
    static int NOTEPAD = 2;
    static int OOD = 3;
    static int PAINT = 4;
    static int CALC = 5;
    static int INTEGRATOR = 6;

    public String getString();
    public BufferedImage getImage();
    public int copiedFrom();  //returns one of the static constants 
    
    //(usage ex.  if(copiedFrom() == TerpClipboardInterface.SPREADSHEET)
}
