import javax.swing.*;
import java.awt.*;
import java.awt.event.*;
import java.io.*;
import java.awt.image.*;
import java.awt.geom.*;

public class bucketTool implements ourTool {
    int imgWidth, imgHeight;  
    
    public bucketTool() {
        super();
    }
    
    public void clickAction(MouseEvent mevt, main_canvas theCanvas) {
       
        System.out.println("The Bucket tool has been clicked");
        int x, y, newRGBValue, boundRGB;
        BufferedImage theImage;
      
        x = theCanvas.canvasScale(mevt.getX());
        y = theCanvas.canvasScale(mevt.getY());
        theImage = theCanvas.getBufferedImage();
        int fill = theCanvas.left_color.getRGB();
        Color newC = new Color(fill);
        System.err.println("The new color is " +newC.getRed()+" "+newC.getGreen()+" "+newC.getBlue());
        
        Fill f = new Fill(theImage,x,y,fill);
        theCanvas.setBufferedImage(f.getBufferedImage());
        /*if (SwingUtilities.isLeftMouseButton(mevt)) {
            newRGBValue = theCanvas.left_color.getRGB();
        } else {
            newRGBValue = theCanvas.right_color.getRGB();
        }
        boundRGB = theImage.getRGB(x,y);
        imgWidth = theImage.getWidth();
        imgHeight = theImage.getHeight();
        pour(theImage,boundRGB,newRGBValue,x,y);
        theCanvas.repaint();*/
    }
    
    public void dragAction(MouseEvent mevt, main_canvas theCanvas) {
        
    }
    
    public void mouseReleaseAction(MouseEvent mevt, main_canvas theCanvas) {
        
    }
       
    private void pour(BufferedImage theImage,int boundRGB, int newRGBValue, int x, int y) {
        int curRGB;
        
        if ((x >= 0) && (x < imgWidth) && (y >= 0) && (y < imgHeight)) {
            curRGB = theImage.getRGB(x,y);
            if (curRGB == boundRGB) {
                theImage.setRGB(x,y,newRGBValue);
                pour(theImage,boundRGB,newRGBValue,x-1,y);
                pour(theImage,boundRGB,newRGBValue,x,y-1);
                pour(theImage,boundRGB,newRGBValue,x+1,y);
                pour(theImage,boundRGB,newRGBValue,x,y+1);
            }
        }
    }
}


