import javax.swing.*;
import java.awt.*;
import java.awt.event.*;
import java.io.*;
import java.awt.image.*;
import java.awt.geom.*;

public class pencilTool implements ourTool {
    BufferedImage pencilImage;
    Graphics2D g2D;
    int prevX, prevY;
    
    public pencilTool() {
        super();
    }

    public void clickAction(MouseEvent mevt, main_canvas theCanvas) {
        int x, y;
        
        pencilImage = theCanvas.getBufferedImage();
        g2D = pencilImage.createGraphics();
        theCanvas.setBufferedImage(pencilImage);
        x = theCanvas.canvasScale(mevt.getX());
        y = theCanvas.canvasScale(mevt.getY());
        if (SwingUtilities.isLeftMouseButton(mevt)) {
            pencilImage.setRGB(x,y,theCanvas.left_color.getRGB());
        } else {
            pencilImage.setRGB(x,y,theCanvas.right_color.getRGB());
        }
        prevX = x;
        prevY = y;
    }
     
    public void dragAction(MouseEvent mevt, main_canvas theCanvas) {
        int x, y;
        x = theCanvas.canvasScale(mevt.getX());
        y = theCanvas.canvasScale(mevt.getY());
        if (SwingUtilities.isLeftMouseButton(mevt)) {
            //pencilImage.setRGB(x,y,theCanvas.left_color.getRGB());
            g2D.setColor(theCanvas.left_color);
            g2D.setStroke(new BasicStroke(1));
            g2D.drawLine(prevX,prevY,x,y);
        } else {
            //pencilImage.setRGB(x,y,theCanvas.right_color.getRGB());
            g2D.setColor(theCanvas.right_color);
            g2D.setStroke(new BasicStroke(1));
            g2D.drawLine(prevX,prevY,x,y);
        }
        prevX = x;
        prevY = y;
        theCanvas.repaint();
    } 
    
    public void mouseReleaseAction(MouseEvent mevt, main_canvas theCanvas) {
        int x, y;
        x = theCanvas.canvasScale(mevt.getX());
        y = theCanvas.canvasScale(mevt.getY());
        if (SwingUtilities.isLeftMouseButton(mevt)) {
            //pencilImage.setRGB(x,y,theCanvas.left_color.getRGB());
            g2D.setColor(theCanvas.left_color);
            g2D.setStroke(new BasicStroke(1));
            g2D.drawLine(prevX,prevY,x,y);
        } else {
            //pencilImage.setRGB(x,y,theCanvas.right_color.getRGB());
            g2D.setColor(theCanvas.right_color);
            g2D.setStroke(new BasicStroke(1));
            g2D.drawLine(prevX,prevY,x,y);
        }
        theCanvas.repaint();
    }
       
}
