import javax.swing.*;
import java.awt.*;
import java.awt.event.*;
import java.io.*;
import java.awt.image.*;
import java.awt.geom.*;
import java.util.*;

public class sprayTool implements ourTool {
    int sprayType = 8;
    BufferedImage sprayImage;
    Color theColor;
    
    public sprayTool() {
        super();
    }
    
    public void clickAction(MouseEvent mevt, main_canvas theCanvas) {
        int x, y;
        int angle, length;
        double vector;
        
        sprayImage = theCanvas.getBufferedImage();
        theCanvas.setBufferedImage(sprayImage);
        if (SwingUtilities.isLeftMouseButton(mevt)) {
            theColor = theCanvas.left_color;
        } else {
            theColor = theCanvas.right_color;
        }
        Random r = new Random();
        for (int count = 0; count < sprayType*Math.round(Math.log(sprayType/2));count++) {
            //x = (int)Math.round(Math.random() * sprayType + Math.round(theCanvas.canvasScale(mevt.getX()) - sprayType / 2));
            //y = (int)Math.round(Math.random() * sprayType + Math.round(theCanvas.canvasScale(mevt.getY()) - sprayType / 2));
            
            angle = r.nextInt(360);
            length = r.nextInt((int)(sprayType/2));
            vector = angle*Math.PI*2/360;
            x = (int)(theCanvas.canvasScale(mevt.getX())+length*Math.sin(vector));
            y = (int)(theCanvas.canvasScale(mevt.getY())+length*Math.cos(vector));
            if ((x >=0) && (x < sprayImage.getWidth()) && (y >= 0) && (y < sprayImage.getHeight())) {
                sprayImage.setRGB(x,y,theColor.getRGB());
            }
        }
        theCanvas.repaint();
    }
    
    public void dragAction(MouseEvent mevt, main_canvas theCanvas) {
        int x, y;
        int angle, length;
        double vector;
        
        if (SwingUtilities.isLeftMouseButton(mevt)) {
            theColor = theCanvas.left_color;
        } else {
            theColor = theCanvas.right_color;
        }
        Random r = new Random();
        for (int count = 0; count < sprayType*Math.round(Math.log(sprayType/2));count++) {
           // x = (int)Math.round(Math.random() * sprayType + Math.round(theCanvas.canvasScale(mevt.getX()) - sprayType / 2));
            //y = (int)Math.round(Math.random() * sprayType + Math.round(theCanvas.canvasScale(mevt.getY()) - sprayType / 2));
            
            angle = r.nextInt(360);
            length = r.nextInt((int)(sprayType/2));
            vector = angle*Math.PI*2/360;
            x = (int)(theCanvas.canvasScale(mevt.getX())+length*Math.sin(vector));
            y = (int)(theCanvas.canvasScale(mevt.getY())+length*Math.cos(vector));
            if ((x >=0) && (x < sprayImage.getWidth()) && (y >= 0) && (y < sprayImage.getHeight())) {
                sprayImage.setRGB(x,y,theColor.getRGB());
            }
        }
        theCanvas.repaint();
    }
    
    public void mouseReleaseAction(MouseEvent mevt, main_canvas theCanvas) {
        
    }
 
    public void setSprayType(int newSprayType) {
        sprayType = newSprayType;
    }
}
